'use strict'
require('./check-versions')()

process.env.NODE_ENV = 'production'

require('shelljs/global');
const ora = require('ora')
const rm = require('rimraf')
const path = require('path')
const utils = require('./utils')
const chalk = require('chalk')
const webpack = require('webpack')
const config = require('../config')
let webpackConfig = null;
var fs = require("fs");

var options = process.argv;

if(options[2] == 'web'){
  process.env.LAYOUT_MODE = options[2];
  webpackConfig = require('./webpack.prod.conf')
}
if(options[2] == 'layout' || options[2] == 'frame'){
  process.env.LAYOUT_MODE = options[2];
  // 缓存layout名字到编译环境变量
  if(options.length>3) process.env.LAYOUT_NAME = options[3];
  webpackConfig = require('./webpack.prod.layout.conf')
}
console.log(process.env.LAYOUT_MODE ,process.env.LAYOUT_NAME);
// 清空dist
if(!!process.env.LAYOUT_NAME){
  utils.deleteFolder(`dist\\*`);
  // utils.deleteFolder(`dist\\${process.env.LAYOUT_NAME}`);
  // utils.deleteFolder(`dist\\frame`);
  // utils.deleteFolder(`dist_layout/${process.env.LAYOUT_NAME}.zip`);
}
// utils.deleteFolder('dist\\static');
// fs.unlinkSync(`dist\\index.html`);

const spinner = ora('building for production...')
spinner.start()

rm(path.join(config.build.assetsRoot, config.build.assetsSubDirectory), err => {
  if (err) throw err
  webpack(webpackConfig, (err, stats) => {
    spinner.stop()
    if (err) throw err
    process.stdout.write(stats.toString({
      colors: true,
      modules: false,
      children: false, // If you are using ts-loader, setting this to true will make TypeScript errors show up during build.
      chunks: false,
      chunkModules: false
    }) + '\n\n')

    if (stats.hasErrors()) {
      console.log(chalk.red('  Build failed with errors.\n'))
      process.exit(1)
    }

    console.log(chalk.cyan('  Build complete.\n'))
    console.log(chalk.yellow(
      '  Tip: built files are meant to be served over an HTTP server.\n' +
      '  Opening index.html over file:// won\'t work.\n'
    ))

    if(process.env.LAYOUT_MODE == 'frame' && process.env.LAYOUT_NAME){
      console.log(`执行===》拷贝dist 到${process.env.LAYOUT_NAME}中`);
      utils.deleteFolder(`layout\\frame\\${process.env.LAYOUT_NAME}\\cacheDist`);
      fs.mkdirSync(`layout\\frame\\${process.env.LAYOUT_NAME}\\cacheDist`);
      exec(`XCOPY /s/y dist layout\\frame\\${process.env.LAYOUT_NAME}\\cacheDist`);
    }
    if(process.env.LAYOUT_MODE == 'layout' && process.env.LAYOUT_NAME){

      if(!fs.existsSync(`dist_layout`)){
        fs.mkdirSync(`dist_layout`);
      }

      fs.mkdirSync(`dist\\${process.env.LAYOUT_NAME}`);
      fs.mkdirSync(`dist\\${process.env.LAYOUT_NAME}\\eg`);
      fs.mkdirSync(`dist\\${process.env.LAYOUT_NAME}\\dist`);
      fs.mkdirSync(`dist\\${process.env.LAYOUT_NAME}\\dist\\static`);
      exec(`XCOPY /f dist\\index.html dist\\${process.env.LAYOUT_NAME}\\dist`);

      exec(`XCOPY /s/y dist\\static dist\\${process.env.LAYOUT_NAME}\\dist\\static`);

      console.log('清除打包---')
      utils.deleteFolder('dist\\static');
      utils.deleteFolder(`dist\\index.html`);

      console.log(`执行===》${process.env.LAYOUT_NAME}合并打包`);
      console.log(`注入config文件===》`);

      utils.copyFile(`layout/pages/${process.env.LAYOUT_NAME}/config/config.json`,`dist\\${process.env.LAYOUT_NAME}\\dist\\static\\config.json`);
      utils.copyFile(`layout/pages/${process.env.LAYOUT_NAME}/config/data.json`,`dist\\${process.env.LAYOUT_NAME}\\eg\\data.json`);
      const config = require(`../layout/pages/${process.env.LAYOUT_NAME}/config/config.js`);
      if(config.frame){
        console.log(`注入frame到Dist`);
        fs.mkdirSync(`dist\\frame`);
        fs.mkdirSync(`dist\\frame\\dist`);
        exec(`XCOPY /s/y layout\\frame\\${config.frame}\\cacheDist dist\\frame\\dist`);
      }
        setTimeout(()=>{
          console.log(`开始压缩===》`);

          var adm_zip = require('adm-zip');
            var zip = new adm_zip();
            zip.addLocalFolder(`dist`);
            zip.writeZip(`dist_layout/${process.env.LAYOUT_NAME}.zip`);
        },200)


    }
  })
})
