/**
 * @author wangwei
 * Date: 18/5/8
 */
require('./check-versions')();
require('shelljs/global');

var inquirer = require('inquirer');
var chalk = require('chalk');
const utils = require('./utils/publishUtils')
var fs = require("fs");
var package = require("../package.json");

var config = null;

var deleteFolder = function (path) {
  var files = [];
  if (fs.existsSync(path)) {
    files = fs.readdirSync(path);
    files.forEach(function (file, index) {
      var curPath = path + "/" + file;
      if (fs.statSync(curPath).isDirectory()) { // recurse
        deleteFolder(curPath);
      } else { // delete file
        fs.unlinkSync(curPath);
      }
    });
    fs.rmdirSync(path);
  }
};

let choDistMode = function () {
  inquirer.prompt([{
    name: 'conform',
    message: `选择需要编译的工程`,
    type: 'list',
    default: 0,
    choices: [{
      name: '编译业务组件',
      value: 1
    }, {
      name: '编译栏目',
      value: 2
    }, {
      name: '编译pc-ui组件',
      value: 3
    }, {
      name: '编译m-ui组件',
      value: 4
    }, {
      name: '全组件编译=>发布',
      value: 99
    }]
  }]).then(function (answers) {
    switch (answers.conform) {
      case 1:
        config = require('../packages/config.js');
        dist();
        break;
      case 2:
        config = require('../packages_columns/config.js');
        dist();
        break;
      case 3:
        config = require('../packages_pc_ui/config.js');
        dist();
        break;
      case 4:
        config = require('../packages_m_ui/config.js');
        break;
      case 99:
        svnupdate(()=>{
          config = require('../packages/config.js');
          runAll();
          config = require('../packages_columns/config.js');
          runAll();
          config = require('../packages_pc_ui/config.js');
          runAll();
          config = require('../packages_m_ui/config.js');
          runAll();
          console.log(chalk.green(`------>编译公共js`));
          exec('npm run build:utils');
          exec('npm run build:cpAssets');
          // 发布
          console.log(chalk.green(`--》发布《--`));
          compPublish();
        });
        break;
      default:
        console.log("状态无效！")
        break;
    }
  })
}
let runAll = function () {

  console.log(chalk.green(`------>扫描packages文件夹`));
  let files = fs.readdirSync(config.dir);
  console.log(chalk.green(`------>生成json`));
  let componentsJson = utils.dirToJson(files, config);
  console.log(componentsJson)
  console.log(chalk.green(`------>重写componentsJson`));
  fs.writeFileSync(config.componentsPath + config.componentsJson, JSON.stringify(componentsJson));
  // 全工程构建
  console.log(chalk.green(`------>清除componentsSubJson`));
  fs.unlink(config.componentsPath + config.componentsSubJson, function () {

  })
  console.log(chalk.green(`------>清除lib`));
  // exec('rimraf lib');
  deleteFolder(config.lib);
  console.log(chalk.green(`------>编译pkg`));
  exec(`npm run build:pkg -- all ${config.name}`);
}
let dist = function () {
  inquirer.prompt([{
    name: 'conform',
    message: `是否需要全工程构建？`,
    type: 'list',
    default: 1,
    choices: [{
      name: '是',
      value: 1
    }, {
      name: '否',
      value: 0
    }]
  }, {
    name: 'message',
    message: '版本发布说明',
    type: 'input',
    default: ''
  }]).then(function (answers) {
    console.log(chalk.green(`------>扫描packages文件夹`));
    fs.readdir(config.dir, function (err, files) {
      console.log(chalk.green(`------>生成json`));
      let componentsJson = utils.dirToJson(files, config);
      console.log(componentsJson)
      console.log(chalk.green(`------>重写componentsJson`));
      fs.writeFileSync(config.componentsPath + config.componentsJson, JSON.stringify(componentsJson));
      // 全工程构建
      if (answers.conform) {
        console.log(chalk.green(`------>清除componentsSubJson`));
        fs.unlink(config.componentsPath + config.componentsSubJson, function () {

        })
        console.log(chalk.green(`------>清除lib`));
        // exec('rimraf lib');
        deleteFolder(config.lib);
        console.log(chalk.green(`------>编译pkg`));
        exec(`npm run build:pkg -- all ${config.name}`);
        // console.log(chalk.green(`------>编译index`));
        // exec('npm run build:index');
        console.log(chalk.green(`------>编译公共js`));
        exec('npm run build:utils');
        exec('npm run build:cpAssets');
        // 发布
        compPublish();
      } else {
        let componentsSubJson = fs.existsSync(config.componentsPath + config.componentsSubJson);
        if (componentsSubJson) {
          compRepeatAns(componentsJson);
        } else {
          compChoicePkg(componentsJson);
        }
      }
    })
  })
}

let svnupdate = function (cannback) {
  inquirer.prompt([{
    name: 'conform',
    message: `是否更新svn？`,
    type: 'list',
    default: 0,
    choices: [{
      name: '是',
      value: 1
    }, {
      name: '否',
      value: 0
    }]
  }]).then(function (answers) {
    if (answers.conform) {
      exec('svn update');
      cannback();
    } else {
      cannback();
    }
  })
};


let compWebAns = function (componentsJson) {
  inquirer.prompt([{
    name: 'conform',
    message: `是否构建web工程？`,
    type: 'list',
    default: 0,
    choices: [{
      name: '是',
      value: 1
    }, {
      name: '否',
      value: 0
    }]
  }]).then(function (answers) {
    if (answers.conform) {
      console.log(chalk.green(`------>web工程`));
      exec('npm run build');
      compPublish();
    } else {
      compPublish();
    }
  })
}

let compPublish = function (componentsJson) {
  inquirer.prompt([{
    name: 'conform',
    message: `是否发布工程到仓库？`,
    type: 'list',
    default: 1,
    choices: [{
      name: '是',
      value: 1
    }, {
      name: '否',
      value: 0
    }]
  }]).then(function (answers) {
    if (answers.conform) {
      console.log(`npm unpublish ${package.name} --force`)
      exec(`npm unpublish ${package.name} --force`);
      console.log(`npm publish`)
      exec('npm publish');
    }
  })
}


let compRepeatAns = function (componentsJson) {
  inquirer.prompt([{
    name: 'conform',
    message: `是否重复上次工程构建？`,
    type: 'list',
    default: 0,
    choices: [{
      name: '是',
      value: 1
    }, {
      name: '否',
      value: 0
    }]
  }]).then(function (answers) {
    if (answers.conform) {
      // 读取上次构建
      var componentsSubJson = JSON.parse(fs.readFileSync(config.componentsPath + config.componentsSubJson));
      console.log(componentsSubJson)
      exec(`npm run build:pkg -- sub ${config.name}`);
      compPublish();
    } else {
      compChoicePkg(componentsJson)
    }
  })
}
// 选择构建
let compChoicePkg = function (componentsJson) {
  let choices = [];
  Object.keys(componentsJson).forEach((key) => {
    let choice = {};
    choice.name = key;
    choice.value = key;
    choices.push(choice);
  })
  inquirer.prompt([{
    name: 'pkgList',
    message: `选择需要重新构建的包？[a]全选[space]选择/取消`,
    type: 'checkbox',
    choices: choices
  }]).then(function (answers) {
    console.log(answers.pkgList);
    if (answers.pkgList && answers.pkgList.length) {
      let componentsSubJson = {};
      answers.pkgList.forEach(item => {
        componentsSubJson[item] = componentsJson[item]
      });
      fs.writeFileSync(config.componentsPath + config.componentsSubJson, JSON.stringify(componentsSubJson));

      exec(`npm run build:pkg -- sub ${config.name}`);
      // console.log(chalk.green(`------>编译公共js`));
      // exec('npm run build:utils');
      // exec('npm run build:cpAssets');
      compPublish();
    }

  })
}
choDistMode();
