# 通用分页 组件
----
### 引入
```
import Cap4BasePage from 'cap4-business/lib/cap4-base-page';
import 'cap4-business/lib/cap4-base-page/css/cap4-base-page.css';
```

### 用法
- 引入分页组件来实现分页效果
- 引入分页组件必须用有height的相对元素包裹起来
- 图标依赖于 cap4字体库

### 示例
<script>
  export default{
    data () {
      return {
        pageData: {
          maxPageSize: 999,
          page: 1,
          pageSize: 20,
          total: 700
        }
      }
    },
    methods: {
      pageChange(args){
        console.log(args)
      }
    }
  }
</script>
<div class="demo-block">
  <div style="height:50px;position:relative">
    <cap4-base-page :data="pageData" @pageEvent="pageChange"></cap4-base-page>
  </div>
</div>

::: demo
```html

<script>
  export default{
    data () {
      return {
        pageData: {
          maxPageSize: 999,
          page: 1,
          pageSize: 20,
          total: 700
        }
      }
    },
    methods: {
      pageChange(args){
        console.log(args)
      }
    }
  }
</script>
<div class="demo-block">
  <div style="height:50px;position:relative">
    <cap4-base-page :data="pageData" @pageEvent="pageChange"></cap4-base-page>
  </div>
</div>

```
:::

### Attributes
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|data      |	传入的data  |	 Object   |	  —     |	—       |

### data
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|total      |	总数(必填) |	Number   |	—           |	—       |
|pageSize      |	每页显示的条数(必填)  |	Number   |	—           |	—       |
|page      |	当前页数(必填) |	Number   |	—           |	—       |
|maxPageSize      |	每一页最大长度 |	Number   |	—           |	—       |

### Event
| 事件名称      | 说明       | 回调参数   |
|------------- |----------- |---------  |
|pageEvent   | 页数改变回调  |  {page, pageSize}  |

