# 批量更新组件
----
用于批量更新

### 基本用法
通过v-if 来动态加载批量更新模块

<div class=" demo-block">
  <img src="@/assets/image/bulk-update.png" />
</div>

::: demo
```html

<script>
  export default{
    data () {
        return {
          isShow: false,
          params: {
            appId:'', // your appId
            formId:'', // your formId
            bindAuthId: '', // your bindAuthId
            size: 10, // Data List 数据条数 必填
            lockNum: 2, //锁定条数 必填
            checkObjLen: 2, //选中条数 必填
            checkObj: [], //选中的数据 必填
          }
        }
    },
    methods: {
    }
  }
</script>

<div class=" demo-block">
  <a href="javascript:;" @click="isShow = true">批量修改</a>
  <cap4-bulk-update v-if="isShow" :params="params"></cap4-bulk-update>
</div>

```
:::

### Attributes
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|params      |	参数 (必填)) |	Object   |	—           |	—       |
|path	      | 网站path     |	string   | /seeyon/common/cap4/template/base/cap4-bulk |

### params
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|appId      |	appId (必填) |	String   |	—           |	—       |
|formId      |	formId (必填) |	String   |	—           |	—       |
|bindAuthId      |	bindAuthId (必填) |	String   |	—           |	—       |
|size      |	Data List 数据条数 (必填) |	Number   |	—           |	—       |
|lockNum      |	锁定条数 (必填) |	Number   |	—           |	—       |
|checkObjLen      |	选中条数 (必填) |	Number   |	—           |	—       |
|checkObj      |	选中的数据 (必填) |	Array   |	—           |	—       |

### Event
| 事件名称      | 说明       | 回调参数   |
|------------- |----------- |---------  |
|success         |成功回调| —  |
|close         |关闭回调| —  |
