# 环形图
----
buttons列表组件

### 基本用法
通过传入props来展示button组

<div class="demo-block" style="background-color: #1F85EC">
  <Cap4DoughnutChart :percent="100" :title="'统计率'"></Cap4DoughnutChart>
</div>

::: demo
```html
  <Cap4DoughnutChart :percent="100" :title="'统计率'"></Cap4DoughnutChart>
```
:::

### Attributes
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|size      |	canvas宽高 |	Number   |	—           |	150       |
|padding	      | canvas边距     |	Number   | —  | 10       |
|percent	      | 绘制的百分比     |	Number   | —  | 0       |
|lineWidth	      | 绘制的线宽     |	Number   | —  | 5       |
|title	      | 中间显示标题     |	String   | —  | 0       |
|animation	      | 动画开关     |	Boolean   | —  | 0       |
|circleOption	      | 圆环轨道参数集合     |	Object   | —  |     参照【circleOption】 |
|ringOption	      | 圆弧参数集合     |	Object   | —  |     参照【ringOption】 |
|pointOption	      | 圆弧头部亮点参数集合     |	Object   | —  |     参照【pointOption】 |
|fontOption	      | 圆弧头部亮点参数集合     |	Object   | —  |     参照【fontOption】 |

### circleOption
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|strokeStyle      |	边的颜色  |	String   |	—           |	 '#57b3ff'       |
|fillStyle      |	填充色 |	String   |	—           |	'#57b3ff'       |

### ringOption
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|strokeStyle      |	边的颜色  |	String   |	—           |	'white'       |
|fillStyle      |	填充色 |	String   |	—           |	'white'       |

### pointOption
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|strokeStyle      |	边的颜色 ( |	String   |	—           |	—       |
|fillStyle      |	填充色 |	String   |	—           |	—       |
|shadowColor      |	虚化颜色 |	String   |	—           |	rgba(255,255,255,0.8)       |
|shadowBlur      |	虚化长度 |	Number   |	—           |	8       |
|radius      |	半径 |	Number   |	—           |	9       |

### fontOption
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|fontGradient      |	百分比字体渐变色设置【两位数组】  |	Array   |	['red','blue']           |	—       |
|percentStyle      |	百分比字体样式  |	String   |	—           |	bold 40px Arial       |
|titleStyle      |	标题字体样式  |	String   |	—           |	12px Arial      |
|fontColor      |	标题和百分比字体初始颜色，未设置渐变色生效  |	String   |	—           |	white      |
