# 统计表格组件
----
### 引入
```
import Cap4StatisticsPcTable from 'cap4-business/lib/cap4-statistics-pc-table';
import  'cap4-business/lib/cap4-statistics-pc-table/css/cap4-statistics-pc-table.css';
```
### 用法
统计专用table，内部包含统计数据解析逻辑。
直接传入后台返回数据，外部得处理穿透跳转逻辑。

### 示例

<script>
  import {data} from './egdata/statisticsData2.js'

  export default{
    data () {
       return {
          tablePage : {
               pageSize : 50,
               page : 1,
               total : 0
          },
          titleOption:{
            startDate:'', // 截止日期
            strConditions:[{
              leftChar:'(',
              fieldName:'文本1',
              operation:'=',
              fieldValue:'1',
              rightChar:')',
              rowOperation:'and'
            }], // 查询条件
            searchTime:'2017-02-11 11:11:11', // 查询日期
            title:'测试列表'
          },
          dataInfo: data
       }
    },
    methods: {
       penetrationClick(item) {
            alert('穿透：'+JSON.stringify(item))
       }
    }
  }
</script>

<div class="demo-block">
  <div style="height:200px">
    <Cap4StatisticsPcTable
      @penetration="penetrationClick"
      :titleOption="titleOption"
      :initHeigth="200"
      :tablePage="tablePage"
      :dataInfo="dataInfo">
    </Cap4StatisticsPcTable>
  </div>
</div>

::: demo
```html
<script>
  import {data} from './egdata/statisticsData.js'

  export default{
    data () {
       return {
          tablePage : {
               pageSize : 50,
               page : 1,
               total : 0
          },
          titleOption:{
            startDate:'', // 截止日期
            strConditions:[{
              leftChar:'(',
              fieldName:'文本1',
              operation:'=',
              fieldValue:'1',
              rightChar:')',
              rowOperation:'and'
            }], // 查询条件
            searchTime:'2017-02-11 11:11:11', // 查询日期
            title:'测试列表'
          },
          strConditions:[],
          dataInfo: data
       }
    },
    methods: {
       penetrationClick(item) {
            alert('穿透：'+JSON.stringify(item))
       }
    }
  }
</script>
<Cap4StatisticsPcTable
    @penetration="penetrationClick"
    :titleOption="titleOption"
    :initHeigth="200"
    :tablePage="tablePage"
    :dataInfo="dataInfo">
</Cap4StatisticsPcTable>
```
:::

### Attributes
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|dataInfo  |	统计数据                        |	object   |	—           |	—       |
|hub	  | 查询组件联动事件中心                  |	object    |	—           |	— |
|tablePage |	分页信息               |	object    |	—             |	—      |
|print |	是否是打印态                |	string    |	—             |	—      |
|localStorageKey |	缓存列头拉动信息用key               |	string    |	—             |	—      |
|initHeigth |	初始化高度                |	Number    |	—             |	—      |
|unShowColFilter |	屏蔽列字段               |	string    |	—             |	—      |




### Event
| 事件名称      | 说明       | 回调参数   |
|------------- |----------- |---------  |
|penetration         |穿透调用事件| item:穿透用参数集合  |
|pageChange         |table内部产生行筛选导致分页变化回调| page |
|resizeEd         |渲染完成后返回总高和总宽，用于打印态参数| {} |
|onGetHeaderList         |取得右上角列树形合集|   |
