# 统计图配套用外挂列表，支持联动

----
`cap4-statistics-pie-list`组件

### 基本用法

<script>
  import {data} from './egdata/statisticsData.js'
  export default{
    data () {
       return {
          itemStyle:{'margin-left': '50px'},
          selectGroup:'',
          dataInfo: data,
          params:null,
          echartDataInfo:null
       }
    },
    methods: {
       penetrationClick(item) {
            alert('穿透：'+JSON.stringify(item))
       },
       outData(echartDataInfos){
          if(echartDataInfos && echartDataInfos.length > 0){
              this.echartDataInfo = echartDataInfos[0];
          }

       }
    }
  }
</script>

<div class="demo-block" >
      <div style="height:300px;width:100%;">
        <Cap4StatisticsPieGroup
          :size="250"
          :selectIndex="1"
          @outData="outData"
          v-model="params"
          :selectGroup="selectGroup"
          :dataInfo="dataInfo">
        </Cap4StatisticsPieGroup>
      </div>
      <div style="height:200px;width:100%;">
          <cap4-statistics-pie-list v-model="params" @penetrateEnable="penetrationClick" :echartDataInfo="echartDataInfo"></cap4-statistics-pie-list>
      </div>
</div>

::: demo
```html
<script>
  import {data} from './egdata/statisticsData.js'
  export default{
    data () {
       return {
          itemStyle:{'margin-left': '50px'},
          selectGroup:'',
          dataInfo: data,
          params:null,
          echartDataInfo:null
       }
    },
    methods: {
       penetrationClick(item) {
            alert('穿透：'+JSON.stringify(item))
       },
       outData(echartDataInfos){
          if(echartDataInfos && echartDataInfos.length > 0){
              this.echartDataInfo = echartDataInfos[0];
          }

       }
    }
  }
</script>

<div class="demo-block" style="">
      <div style="height:300px;width:100%;">
        <Cap4StatisticsPieGroup
          :size="250"
          :selectIndex="1"
          @outData="outData"
          v-model="params"
          :selectGroup="selectGroup"
          :dataInfo="dataInfo">
        </Cap4StatisticsPieGroup>
      </div>
      <div style="height:300px;width:100%;">
          <cap4-statistics-pie-list v-model="params" @penetrateEnable="penetrationClick" :echartDataInfo="echartDataInfo"></cap4-statistics-pie-list>
      </div>
</div>
```
:::

### Attributes
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|echartDataInfo      |	由饼图outData后的数据 |	Object   |	—           |	—       |


### Event
| 事件名称      | 说明       | 回调参数   |
|------------- |----------- |---------  |
|penetrateEnable         |穿透回调| —  |

