# 上传组件
----
用于Excel上传

### 基本用法
通过v-if 来动态加载Excel上传

<div class="demo-block">
  <img src="@/assets/image/upload-excel.png" />
</div>

::: demo
```html

<script>
  export default{
    data () {
        return {
          isShow: false,
          ctxPath: null,
          mineGetUrlSurffix: null
        }
    },
    methods: {
      uploadSuccess(data){
      }
    }
  }
</script>

<div class=" demo-block">
  <a href="javascript:;" @click="isShow = true">选择文件</a>
  <cap4-upload-excel 
    v-if="isShow" 
    :ctxPath="ctxPath"
    :mineGetUrlSurffix="mineGetUrlSurffix"
    @upload-success="uploadSuccess"
    @close="isShow = false"/>
</div>

```
:::

### Attributes
| 参数      | 说明                                 | 类型      | 可选值       | 默认值   |
|---------- |------------------------------------ |---------- |------------- |-------- |
|ctxPath      |	ctxPath(必填) |	string   |	—           |	—       |
|mineGetUrlSurffix(必填)	      | mineGetUrlSurffix     |	string   | - |
|path	      | 网站path     |	string   | /seeyon/common/cap4/template/base/cap4-bulk |

### Event
| 事件名称      | 说明       | 回调参数   |
|------------- |----------- |---------  |
|upload-success      | 成功回调| —  |
|close         |关闭回调| —  |
