
# GFM语法解读

----
```md
大标题
====
```
在文本下面加上 等于号 = ，那么上方的文本就变成了大标题。等于号的个数无限制。

本组件库文档从中标题开始使用。

```md
中标题
-------
```
在文本下面加上 下划线 - ，那么上方的文本就变成了中标题同样的下划线个数无限制。


除此之外，你也会发现大，中标题下面都有一条横线，没错这就是 = 和 - 的显示结果。

如果你只输入了等于号=，但其上方无文字，那么就只会显示一条直线。如果上方有了文字，但你又只想显示一条横线，而不想把上方的文字转义成大标题的话，那么你就要在等于号=和文字直接补一个空行。

补空行：是很常用的用法，当你不想上下两个不同的布局方式交错到一起的时候，就要在两种布局之间补一个空行。


```md
# 一级标题
## 二级标题
### 三级标题
#### 四级标题
##### 五级标题
###### 六级标题
```
>注意井号#和标题名称要并排写作一行，显示效果：

# 一级标题
## 二级标题
### 三级标题
#### 四级标题
##### 五级标题
###### 六级标题


## 普通文本
```md
这是一段普通的文本，
直接回车不能换行，<br>
要使用\<br>
```
直接输入的文字就是普通文本。需要注意的是要换行的时候不能直接通过回车来换行，需要使用`<br>(或者<br/>)  `。也就是html里面的标签。事实上，markdown支持一些html标签，你可以试试。当然如果你完全使用html来写的话，就丧失意义了，毕竟markdown并非专门做前端的，然而仅实现一般效果的话，它会比html写起来要简洁得多得多啦。

注意第三行的`<br>`前加了反斜杠 \ 。目的就是像其他语言那样实现转义，也就是 <  的转义。

此外，要显示一个超链接的话，就直接输入这个链接的URL就好了。显示出来会自动变成可链接的形式的。

补充： 联系两个回车也能达到换行的效果。也就是在文档中有个空行，表现为真正页面的换行。

## 插入代码片段
写法如下：(注意包围符合)

![](../assets/image/code.jpg)


## 单行文本
使用两个Tab符实现单行文本。

## 部分文字的高亮
如果你想使一段话中部分文字高亮显示，来起到突出强调的作用，那么可以把它用 ````  ```` 包围起来。注意这不是单引号，而是Tab上方，数字1左边的按键（注意使用英文输入法）。

写法：
```md
Thank `You` . Please `Call` Me `Coder`
```

效果：
Thank `You` . Please `Call` Me `Coder`

## 文字超链接
给一段文字加入超链接的格式是这样的 [ 要显示的文字 ]( 链接的地址 )。比如：
```md
[我的博客](http://blog.csdn.net/xxxx)
```
显示效果：
[我的博客](http://blog.csdn.net/xxxx)


## 插入符号
### 圆点符
```md
* 昵称：CAP4项目组
```
要注意的是星号* 后面要有一个空格。否则显示为普通星号。上文的显示效果如图：

* 昵称：CAP4项目组

此外还有二级圆点和三级圆点。就是多加一个Tab。


### 缩进
```md
>数据结构
>>树
>>>二叉树
>>>>平衡二叉树
>>>>>满二叉树
```
显示效果：
> 数据结构
>> 树
>>> 二叉树
>>>> 平衡二叉树
>>>>> 满二叉树

## 插入图片
叹号! + 方括号[ ] + 括号( ) 其中叹号里是图片的URL。在方括号里可以加入一些 标识性的信息，比如
```md
![](http://www.baidu.com/img/bdlogo.gif)
![baidu](http://www.baidu.com/img/bdlogo.gif)
```
这个方括号里的baidu并不会对图像显示造成任何改动，如果你想达到鼠标悬停显示提示信息，那么可以仿照前面介绍的文本中的方法，就是这样：
```md
![baidu](http://www.baidu.com/img/bdlogo.gif "百度logo")
```
### 给图片加上超链接
```md
[![baidu]](http://baidu.com)
[baidu]:http://www.baidu.com/img/bdlogo.gif "百度Logo"
```
