# eg数据配置模版
**说明**：`各类型eg数据配置模版，data.js文件配置`<br />
&nbsp;&nbsp;&nbsp;**注**：`最好的方式是从配置了数据源的模版首页返回数据中直接复制，有些字段类型和显示格式直接修改数据比较麻烦`
### 快捷入口
type=`5,8`快捷方式和菜单合集
::: demo
```json
  "30263984-0646-49C6-BD8F-780ACEE28520":{
		"shortCut":[
			{
				"appId":"",
				"menuName":"快捷入口",
				"type":"flowCreateMenuCollection",
				"isUseCustomTemplate":"0"
			}
		]
	}
```
### 统计指标
type=`4`业务指标
::: demo
```json
"E9640231-5E99-4D15-8FAC-57A3CA03F07C":{
	"realValue":240000,
	"originalField":{
		"name":"field0010",
		"display":"待收款金额",
		"dbType":"DECIMAL",
		"length":"20",
		"digitNum":"2",
		"fieldComType":"text",
		"formatType":"format_thousand",
		"enumId":0,
		"systemField":false,
		"properties":{},
		"aliasTableName":"formmain_0042",
		"category":"cap4biz",
		"tableName":"formmain_0042",
		"comType":"TEXT"
	},
	"display":"240,000.00",
	"name":"待收款金额"
}
```
### 有流程待办数
type=`4`有流程待办已办待发已发业务指标
::: demo
```json
"02D610C1-8C22-4727-9702-73C08589203B":{
	"realValue":1,
        "originalField":{
			"dbType":"DECIMAL",
			"comType":"TEXT"
		},
	"display":"1",
	"name":"待办合计数"
}
```
### 有流程列表
type=`3`流程列表
::: demo
```json
"A73CF30A-BBB0-4758-8F64-F458B305F9D3":{
	"type":"listPending",
	"flows":[
		{
			"reminders":"0",
			"handleTerm":"无",
			"formViewOperation":"4954149639699450423",
			"importance":"1",
			"isRead":"0",
			"templateId":"-8661797005139622106",
			"title":"有流程标题",
			"hasAttitude":"1",
			"flowTerm":"无",
			"senderId":"4962427053991153567",
			"handleStateType":"11",
			"processId":"3495114822048368449",
			"currentHandler":"当前处理人",
			"masterDataId":"6447691622265819197",
			"hasAttsFlag":"0",
			"hasOpinion":"1",
			"summaryId":"4897577783761922956",
			"handleStateName":"未读",
			"flowFinished":"0",
			"affairId":"-3848789854319393594",
			"parentHandler":"上一处理人",
			"sendTime":"01-10 14:00",
			"imgUrl":"/seeyon/apps_res/v3xmain/images/personal/pic.gif",
			"receiveTime":"2018-01-10 14:00",
			"noteType":"collaboration",
			"sender":"发送者",
			"createTime":"2018-01-10",
			"currentNoteName":"协同",
			"trackState":"0"
		}
	],
	"formDatas":{
		"6447691622265819197":[
			{
				"showValue":"3,000.00",
				"fieldName":"field0015",
				"display":"报销金额",
				"inputType":"text",
				"value":"3000.00",
				"fieldType":"DECIMAL"
			},
			{
				"showValue":"20,000.00",
				"fieldName":"field0014",
				"display":"预算剩余",
				"inputType":"text",
				"value":"20000.00",
				"fieldType":"DECIMAL"
			}
		]
	}
}
```
### 统计结果
type=`2`统计直接出结果
::: demo
```json
"C5A33BE8-89EF-4F6A-BD78-FEFD5BA37840":{
    "statisticsData":{
        "data":[
            {
                "formmain_0042_field0013":[
                    null,
                    null
                ],
                "formmain_0042_field0012":[
                    null,
                    null
                ],
                "formmain_0042_field0015":[
                    null,
                    null
                ],
                "formmain_0042_field0014":[
                    null,
                    null
                ],
                "formmain_0042_start_member_id":[
                    null,
                    null
                ],
                "formmain_0042_field0011":[
                    null,
                    null
                ],
                "formmain_0042_field0010":[
                    null,
                    null
                ],
                "col_0_formmain_0042_field0020":[
                    "1",
                    1
                ],
                "col_0_formmain_0042_start_member_id":[
                    "1",
                    1
                ],
                "col_0_formmain_0042_field0002":[
                    "1,000,000",
                    1000000
                ],
                "col_0_formmain_0042_field0003":[
                    "900,000",
                    900000
                ],
                "col_0_formmain_0042_field0004":[
                    "95%",
                    0.95
                ],
                "rowType":null,
                "col_0_formmain_0042_field0005":[
                    "140,000.00",
                    140000
                ],
                "col_0_formmain_0042_field0006":[
                    "230,000.00",
                    230000
                ],
                "col_0_formmain_0042_field0007":[
                    "500,000.00",
                    500000
                ],
                "col_0_formmain_0042_field0008":[
                    "120,000.00",
                    120000
                ],
                "col_0_formmain_0042_field0009":[
                    "100,000.00",
                    100000
                ],
                "formmain_0042_field0009":[
                    null,
                    null
                ],
                "formmain_0042_field0006":[
                    null,
                    null
                ],
                "formmain_0042_field0005":[
                    null,
                    null
                ],
                "formmain_0042_field0008":[
                    null,
                    null
                ],
                "formmain_0042_field0007":[
                    null,
                    null
                ],
                "formmain_0042_field0002":[
                    null,
                    null
                ],
                "formmain_0042_field0001":[
                    "申请金额1",
                    "申请金额1"
                ],
                "formmain_0042_field0004":[
                    null,
                    null
                ],
                "formmain_0042_field0003":[
                    null,
                    null
                ],
                "formmain_0042_field0020":[
                    null,
                    null
                ],
                "rowSumKey":null,
                "col_0_formmain_0042_field0010":[
                    "240,000.00",
                    240000
                ],
                "col_0_formmain_0042_field0011":[
                    "980,000.00",
                    980000
                ],
                "col_0_formmain_0042_field0012":[
                    "30,000.00",
                    30000
                ],
                "col_0_formmain_0042_field0013":[
                    "10,000.00",
                    10000
                ],
                "col_0_formmain_0042_field0014":[
                    "20,000.00",
                    20000
                ],
                "col_0_formmain_0042_field0015":[
                    "3,000.00",
                    3000
                ],
                "col_0_formmain_0042_field0017":[
                    "1",
                    1
                ],
                "col_0_formmain_0042_field0019":[
                    "1",
                    1
                ],
                "formmain_0042_field0017":[
                    null,
                    null
                ],
                "formmain_0042_field0019":[
                    null,
                    null
                ]
            },
            {
                "formmain_0042_field0013":[
                    null,
                    null
                ],
                "formmain_0042_field0012":[
                    null,
                    null
                ],
                "formmain_0042_field0015":[
                    null,
                    null
                ],
                "formmain_0042_field0014":[
                    null,
                    null
                ],
                "formmain_0042_start_member_id":[
                    null,
                    null
                ],
                "formmain_0042_field0011":[
                    null,
                    null
                ],
                "formmain_0042_field0010":[
                    null,
                    null
                ],
                "col_0_formmain_0042_field0020":[
                    "1",
                    1
                ],
                "col_0_formmain_0042_start_member_id":[
                    "1",
                    1
                ],
                "col_0_formmain_0042_field0002":[
                    "1,000,000",
                    1000000
                ],
                "col_0_formmain_0042_field0003":[
                    "900,000",
                    900000
                ],
                "col_0_formmain_0042_field0004":[
                    "95%",
                    0.95
                ],
                "rowType":"1",
                "col_0_formmain_0042_field0005":[
                    "140,000.00",
                    140000
                ],
                "col_0_formmain_0042_field0006":[
                    "230,000.00",
                    230000
                ],
                "col_0_formmain_0042_field0007":[
                    "500,000.00",
                    500000
                ],
                "col_0_formmain_0042_field0008":[
                    "120,000.00",
                    120000
                ],
                "col_0_formmain_0042_field0009":[
                    "100,000.00",
                    100000
                ],
                "formmain_0042_field0009":[
                    null,
                    null
                ],
                "formmain_0042_field0006":[
                    null,
                    null
                ],
                "formmain_0042_field0005":[
                    null,
                    null
                ],
                "formmain_0042_field0008":[
                    null,
                    null
                ],
                "formmain_0042_field0007":[
                    null,
                    null
                ],
                "formmain_0042_field0002":[
                    null,
                    null
                ],
                "formmain_0042_field0001":[
                    null,
                    null
                ],
                "formmain_0042_field0004":[
                    null,
                    null
                ],
                "formmain_0042_field0003":[
                    null,
                    null
                ],
                "formmain_0042_field0020":[
                    null,
                    null
                ],
                "rowSumKey":null,
                "col_0_formmain_0042_field0010":[
                    "240,000.00",
                    240000
                ],
                "col_0_formmain_0042_field0011":[
                    "980,000.00",
                    980000
                ],
                "col_0_formmain_0042_field0012":[
                    "30,000.00",
                    30000
                ],
                "col_0_formmain_0042_field0013":[
                    "10,000.00",
                    10000
                ],
                "col_0_formmain_0042_field0014":[
                    "20,000.00",
                    20000
                ],
                "col_0_formmain_0042_field0015":[
                    "3,000.00",
                    3000
                ],
                "col_0_formmain_0042_field0017":[
                    "1",
                    1
                ],
                "col_0_formmain_0042_field0019":[
                    "1",
                    1
                ],
                "formmain_0042_field0017":[
                    null,
                    null
                ],
                "formmain_0042_field0019":[
                    null,
                    null
                ]
            }
        ],
        "colData":[
            [
                "2018年1月10日",
                "2018_1_10"
            ]
        ]
    },
    "statisticsInfo":{
        "rowHeaders":[
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":false,
                "name":"field0001",
                "aliasDisplay":"标题"
            }
        ],
        "dataSourceNames":"首页有流程",
        "hasCustomTemplate":false,
        "groupMerge":true,
        "colHeaders":{
            "aliasTableName":"formmain_0042",
            "groupType":"day",
            "penetrateEnable":false,
            "name":"field0018",
            "aliasDisplay":"日期"
        },
        "statsFields":[
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0002",
                "formatType":"format_thousand",
                "digitNum":"0",
                "exportDigitNum":"0",
                "aliasDisplay":"今年预算",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0003",
                "formatType":"format_thousand",
                "digitNum":"0",
                "exportDigitNum":"0",
                "aliasDisplay":"去年预算",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0004",
                "formatType":"format_hundred",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"本部门预算执行率",
                "exportFormatType":"format_hundred"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0005",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"支出金额",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0006",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"总金额",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0007",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"可用金额",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0008",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"在途费用",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0009",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"调整金额",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0010",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"待批费用",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0011",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"消费总金额",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0012",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"未报销金额",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0013",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"待还借款",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0014",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"预算剩余",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"sum",
                "name":"field0015",
                "formatType":"format_thousand",
                "digitNum":"2",
                "exportDigitNum":"2",
                "aliasDisplay":"报销金额",
                "exportFormatType":"format_thousand"
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"count",
                "name":"field0017",
                "formatType":"",
                "digitNum":"0",
                "exportDigitNum":"0",
                "aliasDisplay":"类型",
                "exportFormatType":""
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"count",
                "name":"field0019",
                "formatType":"",
                "digitNum":"0",
                "exportDigitNum":"0",
                "aliasDisplay":"操作人",
                "exportFormatType":""
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"count",
                "name":"field0020",
                "formatType":"",
                "digitNum":"0",
                "exportDigitNum":"0",
                "aliasDisplay":"操作部门",
                "exportFormatType":""
            },
            {
                "aliasTableName":"formmain_0042",
                "penetrateEnable":true,
                "calcType":"count",
                "name":"start_member_id",
                "formatType":"",
                "digitNum":"0",
                "exportDigitNum":"0",
                "aliasDisplay":"创建人_系统字段",
                "exportFormatType":""
            }
        ],
        "columnMerge":false,
        "rowMerge":true,
        "filterFields":[
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0001",
                "dbType":"VARCHAR",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"标题",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0002",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"今年预算",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0003",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"去年预算",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0004",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"本部门预算执行率",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0005",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"支出金额",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0006",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"总金额",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0007",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"可用金额",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0008",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"在途费用",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0009",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"调整金额",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0010",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"待批费用",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0011",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"消费总金额",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0012",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"未报销金额",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0013",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"待还借款",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0014",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"预算剩余",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"text",
                "name":"field0015",
                "dbType":"DECIMAL",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"报销金额",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"textarea",
                "name":"field0016",
                "dbType":"VARCHAR",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"备注",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"4171705351394184829",
                "fieldComType":"select",
                "name":"field0017",
                "dbType":"VARCHAR",
                "category":"cap4biz",
                "properties":{
                    "isFinalChild":false,
                    "enumLevel":"0"
                },
                "aliasDisplay":"类型",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"date",
                "name":"field0018",
                "dbType":"TIMESTAMP",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"日期",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"member",
                "name":"field0019",
                "dbType":"VARCHAR",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"操作人",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "enumId":"0",
                "fieldComType":"department",
                "name":"field0020",
                "dbType":"VARCHAR",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"操作部门",
                "tableName":"formmain_0042"
            },
            {
                "aliasTableName":"formmain_0042",
                "fieldComType":"member",
                "name":"start_member_id",
                "dbType":"VARCHAR",
                "category":"cap4biz",
                "properties":{

                },
                "aliasDisplay":"创建人_系统字段",
                "tableName":"formmain_0042"
            }
        ],
        "title":"自定义统计1",
        "radarMax":"8",
        "pieMax":"8"
    }
}
```