# 表单第三方接口文档

------
    表单第三方开发参考文档

<style>
table{display:table!important;margin:16px 0!important;}
table,td,th{border:1px solid #e8e2e2!important;}
img{max-width:600px;}
.sub-tit{margin:16px 0;padding:16px;background-color:#F7F7F7;overflow: auto;}
</style>

<p style="height:15px"></p>

## 第三方开发介绍
	A. 此规范用于第三方对表单进行定制化开发满足标准开发未满足的需求

## 提供的API载体（window.thirdPartyFormAPI）

该全局对象是第三方事件处理的载体，主要包括事件池和功能api两部分。
</br>
</br>

### 表单事件池操作 
    可用作注册事件和触发事件
| 属性      | 说明                                 |参数       |
|---------- |------------------------------------ |------------- |
|registerEvent      |	注册事件 |	 key:事件名称，fn：回调函数	   |
|triggerEvent      |	触发事件 |	 key:事件名称，params：回调参数	   |
注：事件触发是做扩展用，第三方可在事件池中自定义事件并自己触发事件，但是表单内部提供的监听等不需要第三方去触发

- 事件池注册示例：
</br>
</br>
```javascript
    // 注册事件
    window.thirdPartyFormAPI.registerEvent('key', function(params){
        // params 接收参数
    });

    // 触发事件
    window.thirdPartyFormAPI.triggerEvent('key', params);
```

</br>

### 表单提供的事件
#### 表单中控件失去焦点后触发事件（afterFormFieldChange）
    第三方开发要注册此方法
```javascript
    // 注册事件
    window.thirdPartyFormAPI.registerEvent('afterFormFieldChange', function(params){
    ...//params是当前失去焦点的控件的数据
    //如果需要获取主表或明细表数据可用功能api中的getFormData获取
    });

    // params 是一个对象（当前变化控件数据）

```  
![][form-contorl-render-png]
    每个属性具体含义，可以参考自定义控件-前端 3.1 > D
<br />
### 表单提供的功能api
可以操作表单内部回填等功能，事件触发为同步。
| 属性      | 说明                                 |参数       |
|---------- |------------------------------------ |------------- |
|getFormData      |	获取表单数据 |	 fn：回调函数(可不传，为可选参数)(A)	   |
|backfillFormControlData      |	回填数据 |	 data (B)   |
|backfillFormAttachment      |	回填附件，图片 |	data (C)		   |
|changeFormFieldAuth      |	改变控件权限 |		params (D)   |

#### A. getFormData(fn)
*示例^*
```javascript
    // 直接返回值
    window.thirdPartyFormAPI.getFormData();
    // 传入回调方法，值进入回调方法
    window.thirdPartyFormAPI.getFormData(function(result) {
        // result 是返回的数据
    });

    //  formData : 表单数据
    //  formmains : 主表数据
    //  formsons : 明细表数据
```
![][form-get-render-png]
#### B. backfillFormControlData(data)
*示例^*
```javascript
    window.thirdPartyFormAPI.backfillFormControlData(data);
```
		a. 此接口是用于自定义控件回填表单其他控件数据
		b. 参数：数据
			b-1. 数据格式 ：
*示例^*
```javascript
				[ 
					{
						tableName : 表名, 
						tableCategory : 表类型， 
						updateData : { 
							filedName : {} // (控件名) : (控件回填的数据对象) 
						}，
						updateRecordId : 更新的对应的数据行Id
					}
				]
```
				表类型为主表或者明细表（formmain , formson）
			b-2. 回填单个控件就直接用1数组里面第一层格式的对象，回填多个可以用1的数据格式。明细表需要参数对应的数据行ID，主表不用传
			b-3. 后台接口取回的数据直接数据。
			b-4. 前端维护的数据 showValue = showValue, value = showValue2, valueId = value 按这个规则重置后回填数据。

#### C. backfillFormAttachment(data)
*示例^*
```javascript
    window.thirdPartyFormAPI.backfillFormAttachment(data);
```
		a. 此接口用于回填表单里面控件的附件
		b. 参数 ： 数据
			b-1. 数据格式 ：
*示例^*
```javascript
				[
					{
						tableName : 表名, 
						tableCategory : 表类型，
						updateRecordId : 更新的明细表数据行id，
						handlerMode : 操作，
						fieldName : 操作的字段名，
						addAttchmentData : [{}] // 回填的附件列表，[ Object ] 删除的附件信息对象列表
						deleteAttachmentData : [] // 删除的附件列表ID [ String ], 删除的附件Id列表
					}
				]
```
				b-1-1. handlerMode : 操作分为添加add和删除delete
				b-1-2. addAttchmentData 和deleteAttachmentData 根据操作进行对应的回填可不同时存在
			b-2. 回填单个控件就直接用1数组里面第一层格式的对象，回填多个可以用1的数据格式。明细表需要参数对应的数据行ID，主表不用传

#### D. changeFormFieldAuth(params)
```
    // 更新权限
    window.thirdPartyFormAPI.changeFormFieldAuth(params)
```
| 属性      | 说明                                 |可选值       |
|---------- |------------------------------------ |------------- |
|formType      |	表类型 |	 'formmain','formson'   |
|tableName      |	表名 |		   |
|feildID      |	控件ID |		   |
|recordId      |	明细表行记录id |		   |
|auth      |	改变控件权限 |		'edit','browse','hide'   |

##### params示例：
```
{
    formType : 'formmain', // 'formmain','formson'
    tableName : 'formmain_5614',
    feildID : 'field0001',
    recordId : '', // 明细表用，主表传空
    auth : 'hide' // 'edit','browse','hide'
}
```

## 第三方开发调试环境和与表单的交互
	1.协同开发环境.
	2.我们会持续维护表单和自定义控件之间的交互api，如有特殊情况可以联系后讨论处理方案


----------
_End_

[form-get-render-png]: ../assets/image/pc-customform/thirdgetform.png "获取表单数据"
[form-contorl-render-png]: ../assets/image/pc-customform/thirdContorl.png "获取表单数据"
