import Vue from 'vue'
import Router from 'vue-router'
import navConf from '../nav.config.json'
import navCustomConf from '../nav.config.custom.control.json'
import navInterfaceBackConf from '../nav.config.interface.back.json'
import navInterfaceFrontConf from '../nav.config.interface.front.json'
import navTestConf from '../nav.config.test.json'

Vue.use(Router)

let routes = []

Object.keys(navConf).forEach((header) => {
  routes = routes.concat(navConf[header])
})

Object.keys(navCustomConf).forEach((header) => {
  routes = routes.concat(navCustomConf[header])
})

Object.keys(navInterfaceBackConf).forEach((header) => {
  routes = routes.concat(navInterfaceBackConf[header])
})

Object.keys(navInterfaceFrontConf).forEach((header) => {
  routes = routes.concat(navInterfaceFrontConf[header])
})
Object.keys(navTestConf).forEach((header) => {
  routes = routes.concat(navTestConf[header])
})

let addComponent = (router) => {
  router.forEach((route) => {
    if (route.items) {
      addComponent(route.items)
      routes = routes.concat(route.items)
    } else {
      if (route.type === 'pages') {
        route.component = r => require.ensure([], () =>
          r(require(`../pages/${route.name}.vue`)))
        return
      }
      if (route.type === 'custom') {
        route.component = r => require.ensure([], () =>
          r(require(`../docs_custom_control/${route.name}.md`)))
        return
      }
      if (route.type === 'interface-back') {
        route.component = r => require.ensure([], () =>
          r(require(`../docs_interface_back/${route.name}.md`)))
        return
      }
      if (route.type === 'interface-front') {
        route.component = r => require.ensure([], () =>
          r(require(`../docs_interface_front/${route.name}.md`)))
        return
      }
      route.component = r => require.ensure([], () =>
        r(require(`../docs/${route.name}.md`)))
    }
  })
}
addComponent(routes)
export default new Router({
  routes: routes
})
