'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var bind = exports.bind = function bind(elem, event, handler) {
    if (elem && elem !== 'undefined' && event && handler) {

        event = event === 'mousewheel' ? document.onmousewheel !== undefined ? "mousewheel" : "DOMMouseScroll" : event;

        if (document.attachEvent) {

            elem.attachEvent("on" + event, handler);
        } else {

            elem.addEventListener(event, handler, false);
        }
    }
};

var unbind = exports.unbind = function unbind(elem, event, handler) {
    if (elem && elem !== 'undefined' && event && handler) {

        event = event === 'mousewheel' ? document.onmousewheel !== undefined ? "mousewheel" : "DOMMouseScroll" : event;

        var handlers = [];
        if (Array.isArray(handler) && handler.length > 0) {
            handlers = handler;
        } else {
            handlers.push(handler);
        }

        if (document.removeEventListener) {

            handlers.forEach(function (e) {
                elem.removeEventListener(event, e, false);
            });
        } else {

            handlers.forEach(function (e) {
                elem.removeEventListener('on' + event, e);
            });
        }
    }
};