'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = goUrl;
function goUrl(item) {
    var bussId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : getUrlParam('bussId');

    var _ctxPath = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : window._ctxPath;

    var CsrfGuard = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : window.CsrfGuard;

    if (!item) return undefined;
    var url = '';
    switch (item.type) {
        case 'unflowList': // 实际是无流程列表
        case 'unflowMenuCollection':
            // 实际是无流程列表
            url = _ctxPath + '/cap4/businessTemplateController.do?method=capUnflowList&moduleId=' + item.appId + '&businessId=' + bussId + '&formId=' + item.formId + CsrfGuard.getUrlSurffix();
            break;
        case 'queryList': // 实际查询
        case 'queryMenuCollection':
            // 实际是查询
            url = _ctxPath + '/report4Result.do?method=showResult&designType=QUERY&designId=' + item.appId + CsrfGuard.getUrlSurffix();
            break;
        case 'caclList': // 实际是统计
        case 'caclMenuCollection':
            // 实际是统计
            url = _ctxPath + '/report4Result.do?method=showResult&designType=STATISTICS&designId=' + item.appId + CsrfGuard.getUrlSurffix();
            break;
        case 'flowList':
            // 实际是有流程列表 * 有流程只有新建没有列表

            break;
        case 'unFlowCreateMenuCollection': // 实际是无流程新建
        case 'unflowCreate':
            // 实际是无流程新建
            url = _ctxPath + '/cap4/businessTemplateController.do?method=formContent#/create?rightId=-1&moduleId=' + item.appId + '&moduleType=42&formTemplateId=' + item.appId + CsrfGuard.getUrlSurffix();
            break;
        case 'flowCreateMenuCollection': // 实际是有流程新建
        case 'listCreate':
            // 新建
            url = _ctxPath + '/collaboration/collaboration.do?method=newColl&templateId=' + item.appId + CsrfGuard.getUrlSurffix();
            break;
    }
    return url;
}
function getUrlParam(name) {
    var reg = new RegExp("(^|&|#|/?)" + name + "=([^&]*)(&|$)", "i");
    var r = window.location.href.substr(1).match(reg);
    if (r != null) {
        var result = unescape(r[2]);
        if (result.indexOf('#') > 0) {
            result = result.slice(0, result.indexOf('#'));
        };
        return result;
    }
    return null;
}