'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
/*eslint-disable*/
// 后台标识字符
var checkList = [',', '¥', '%'];

//公用转换器 formatMoney => NumberMoney
var moneyToNumber = exports.moneyToNumber = function moneyToNumber(money) {
    var res = 0;
    if (typeof money == 'string') {
        for (var i = 0; i < checkList.length; i++) {
            var before = checkList[i];
            var raRegExp1 = new RegExp(before, "g");
            money = money.replace(raRegExp1, '');
        }
        try {
            res = parseFloat(money);
        } catch (error) {
            res = 0;
        }
    } else if (typeof money == 'number') {
        res = money;
    } else {
        res = 0;
    }
    return res;
};
// 是否是后台format
var isBackFormat = exports.isBackFormat = function isBackFormat(money) {
    money = money + '';

    for (var i = 0; i < checkList.length; i++) {
        var before = checkList[i];
        if (money.indexOf(before) >= 0) return true;
    }
    return false;
};

var getZeroStr = function getZeroStr(num) {
    var res = '';
    for (var i = 0; i < num; i++) {
        res += '0';
    }
    return res;
};

//判断小数点后有几位 mode：1:强制 2：自动
var moneyDecimal = exports.moneyDecimal = function moneyDecimal(money, maxDecimal, mode) {
    var useDecimal = 0;
    var tmpMoney = money.toString();
    var tmpMoneyZ = tmpMoney.indexOf('.');
    if (mode == 1) {
        if (tmpMoneyZ >= 0) {
            var decimal = money.toString().split(".")[1].length;
            if (decimal > maxDecimal) {
                return money.toFixed(maxDecimal);
            } else {
                return money.toFixed(decimal) + getZeroStr(maxDecimal - decimal);
            }
        } else {
            return money + '.' + getZeroStr(maxDecimal);
        }
    }
    if (mode == 2) {
        if (tmpMoneyZ >= 0) {
            var _decimal = money.toString().split(".")[1].length;
            if (_decimal > maxDecimal) {
                useDecimal = maxDecimal;
            } else {
                useDecimal = _decimal;
            }
        }
        var a = money.toFixed(useDecimal);
        return a;
    }
    return money;
};
//  万  亿  万亿 单位转换(小数位)
var moneyFilter = exports.moneyFilter = function moneyFilter(input, decimal, mode) {
    if (!decimal && decimal !== 0) decimal = 2;
    if (!mode) mode = 2;
    var money = moneyToNumber(input);
    // 正数的情况
    if (money < 10000 && money >= 0) {
        return moneyFilter2(input, decimal, mode);
    }
    if (money >= 10000 && money < 100000000) {
        var showMoney = money / 10000;
        return moneyDecimal(showMoney, decimal, mode) + '万';
    }
    if (money >= 100000000 && money < 1000000000000) {
        var _showMoney = money / 100000000;
        return moneyDecimal(_showMoney, decimal, mode) + '亿';
    }
    if (money >= 1000000000000) {
        var _showMoney2 = money / 1000000000000;
        return moneyDecimal(_showMoney2, decimal, mode) + '兆';
    }
    // 负数的情况
    if (money < 0 && money > -10000) {
        return moneyFilter2(input, decimal, mode);
    }
    if (money > -100000000 && money <= -10000) {
        var _showMoney3 = money / 10000;
        return moneyDecimal(_showMoney3, decimal, mode) + '万';
    }
    if (money > -1000000000000 && money <= -100000000) {
        var _showMoney4 = money / 100000000;
        return moneyDecimal(_showMoney4, decimal, mode) + '亿';
    }
    if (money <= -1000000000000) {
        var _showMoney5 = money / 1000000000000;
        return moneyDecimal(_showMoney5, decimal, mode) + '兆';
    }

    return money;
};
//  千分位转换, 带小数点;3 : 可后台适配适配
var formatThousand = exports.formatThousand = function formatThousand(input) {
    var money = moneyToNumber(input);
    var numStr = input + '';
    //
    var index = numStr.indexOf('.');
    if (index >= 0) {
        var z = parseInt(money);
        var x = numStr.substring(index);
        return (z || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,') + x;
    } else {
        return (money || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,');
    }
    return money;
};
//  千分位转换, 带小数点;3 : 可后台适配适配
var moneyFilter2 = exports.moneyFilter2 = function moneyFilter2(input, decimal, mode) {
    if (!decimal && decimal !== 0) decimal = 2;
    if (!mode) mode = 3;
    if (mode == 3 && isBackFormat(input)) {
        mode = 2;
        return input;
    }
    var money = moneyToNumber(input);
    var numStr = moneyDecimal(money, decimal, mode).toString();
    //
    var index = numStr.indexOf('.');
    if (index >= 0) {
        var z = parseInt(money);
        var x = numStr.substring(index);
        return (z || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,') + x;
    } else {
        return (money || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,');
    }
    return money;
};

// 日期适配
var autoFilter = exports.autoFilter = function autoFilter(item, dataInfo, mode) {
    if (!mode) mode = 2;
    var value = '';
    var lable = '';
    var res = '';
    if (!!item) {
        // 日期型
        if (item instanceof Array) {
            lable = item[0] ? item[0] : '';
            value = item[1];
        } else {
            lable = item.lable;
            value = item.value;
        }
        // 如果后端有定义格式，走后端格式化
        if (lable != value + '') {
            res = lable;
        } else {
            // 没有定义格式，走前端格式化
            if (!!value) {
                if (mode == 1) {
                    res = moneyFilter(value);
                }
                if (mode == 2) {
                    res = moneyFilter2(value);
                }
            }
        }
    }
    if (!res && res !== 0) res = '';
    return res;
};