'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _commonUtil = require('../statistics/commonUtil');

exports.default = {
  props: ['column', 'templateId', 'bussId'],
  data: function data() {
    return {
      datas: {},
      keys: []
    };
  },

  computed: {},
  methods: {
    dk: function dk(index, key) {
      var res = null;
      if (!!this.keys && this.keys.length && this.keys.length >= index + 1) {
        res = this.datas[this.keys[index]];
      }
      if (key && res) {
        res = res[key];
      }
      return res;
    },
    getData: function getData(callback) {
      var _this = this;

      this.$httpClient.getDataByColumnIds(this.templateId, this.column).then(function (res) {
        var columnData = _this.$httpClient.resToData(res, _this.column);
        console.log(columnData);
        _this.datas = columnData.datas;
        _this.keys = columnData.keys;
        if (callback) callback();
      }).catch(function (e) {
        _this.datas = {};
        _this.keys = [];
        if (callback) callback();
      });
    },

    // 穿透
    goUrl: function goUrl(item, isEg) {
      if (!item) return;
      // 兼容。。
      if (item.shortCut && item.shortCut instanceof Array) {
        if (item && item.shortCut && item.shortCut.length > 0) {
          isEg = item.isEg;
          item = item.shortCut[0];
        } else {
          return;
        }
      }
      if (isEg == '1') return;
      var bussId = this.bussId;
      var _ctxPath = this.$httpClient.env._ctxPath;
      var url = '';
      switch (item.type) {
        case 'unflowList': // 实际是无流程列表
        case 'unflowMenuCollection':
          // 实际是无流程列表
          url = _ctxPath + '/cap4/businessTemplateController.do?method=capUnflowList&moduleId=' + item.appId + '&businessId=' + bussId + '&formId=' + item.formId + this.$httpClient.getUrlSurffix();
          break;
        case 'queryList': // 实际查询
        case 'queryMenuCollection':
          // 实际是查询
          url = _ctxPath + '/report4Result.do?method=showResult&designType=QUERY&designId=' + item.appId + this.$httpClient.getUrlSurffix();
          break;
        case 'caclList': // 实际是统计
        case 'caclMenuCollection':
          // 实际是统计
          url = _ctxPath + '/report4Result.do?method=showResult&designType=STATISTICS&designId=' + item.appId + this.$httpClient.getUrlSurffix();
          break;
        // case 'flowList':// 实际是有流程列表 * 有流程只有新建没有列表
        //
        //   break;
        case 'unFlowCreateMenuCollection': // 实际是无流程新建
        case 'unflowCreate':
          // 实际是无流程新建
          url = _ctxPath + '/cap4/businessTemplateController.do?method=formContent#/create?rightId=-1&moduleId=' + item.appId + '&moduleType=42&formTemplateId=' + item.appId + this.$httpClient.getUrlSurffix();
          break;
        case 'flowCreateMenuCollection': // 实际是有流程新建
        case 'listCreate':
          // 新建
          url = _ctxPath + '/collaboration/collaboration.do?method=newColl&templateId=' + item.appId + this.$httpClient.getUrlSurffix();
          break;
      }
      if (!!url) {
        window.open(url, item.type, 'width=' + (window.screen.availWidth - 10) + ',height=' + (window.screen.availHeight - 70) + ',top=0,left=0,toolbar=no,menubar=no,scrollbars=no, resizable=no,location=no, status=no');
      }
    },

    // 统计穿透
    penetrationClick: function penetrationClick(item, dataInfo) {
      // 预览不能穿透
      if (this.preview || this.isEg) {
        return;
      }
      if (!this.appId || !this.conditions) {
        alert("data上未绑定appId跟conditions！");
      }
      // 穿透
      var statisticsPopData = (0, _commonUtil.penetrationUtil)(item, this.appId, this.conditions, dataInfo.statisticsData, dataInfo.statisticsInfo);

      if (window.top.$) {
        window.top.$.dialog({
          id: 'stats_penetrate',
          url: statisticsPopData.url,
          title: statisticsPopData.title,
          width: window.screen.width,
          height: this.findParent().innerHeight + 100,
          transParams: statisticsPopData.params
        });
      }
    }
  }
}; /*eslint-disable*/