'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getUrlParams = require('../common/getUrlParams');

exports.default = {
  data: function data() {
    return {
      config: null,
      columns: null,
      bussId: '',
      templateId: ''
    };
  },

  computed: {
    title: function title() {
      if (this.config) {
        return this.config.name;
      } else {
        return '';
      }
    }
  },
  methods: {
    getConfig: function getConfig(callback) {
      var _this = this;

      this.templateId = (0, _getUrlParams.getUrlParam)('templateId');
      this.bussId = (0, _getUrlParams.getUrlParam)('bussId');

      this.$httpClient.getConfig().then(function (res) {
        console.log(res);
        _this.config = res.data;
        _this.columns = res.data.columns;
        if (callback) callback();
      }).catch(function (e) {
        _this.config = null;
        _this.columns = null;
        if (callback) callback();
      });
    },
    getColumn: function getColumn(index) {
      if (this.columns) {
        if (this.columns[index] && this.columns[index].state == '1') {
          return this.columns[index];
        }
      }
      return false;
    }
  }
}; /*eslint-disable*/