'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getUrlParamXms = exports.getUrlParam = exports.penetrationUtil = exports.setRowHeaderName = exports.getMaxData = exports.getSelctList = exports.getColorsByNum2 = exports.getColorsByIndex = exports.getColorsByNum = exports.dataFilter = undefined;

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _constant = require('./constant.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 剔除计算属性，取得lastData
var dataFilter = exports.dataFilter = function dataFilter(dataInfo) {
    if (dataInfo.statisticsData.lastData) {
        return dataInfo;
    }
    if (dataInfo && dataInfo.statisticsData.data) {
        var lastData = dataInfo.statisticsData.data[dataInfo.statisticsData.data.length - 1];
        if (lastData.rowType === '1') {
            dataInfo.statisticsData.lastData = lastData;
            dataInfo.statisticsData.data = dataInfo.statisticsData.data.filter(function (item) {
                return !item.rowType;
            });
        } else {
            // 自己计算
            var comLastData = {};
            for (var i = 0; i < dataInfo.statisticsData.data.length; i++) {
                var item = dataInfo.statisticsData.data[i];
                for (var arr in item) {
                    if (item[arr] && (0, _typeof3.default)(item[arr]) == 'object') {
                        if (!!comLastData[arr]) {
                            comLastData[arr][1] = comLastData[arr][1] + valueToNumber(item[arr][1], 0);
                        } else {
                            comLastData[arr] = [0, 0];
                            comLastData[arr][1] = comLastData[arr][1] + valueToNumber(item[arr][1], 0);
                        }
                    }
                }
            }
            dataInfo.statisticsData.lastData = comLastData;
        }
    }
    return dataInfo;
};

// 轮盘取色器
/*eslint-disable*/
var getColorsByNum = exports.getColorsByNum = function getColorsByNum(num) {
    if (num > _constant.colors.length) {
        var count = Math.ceil(num / _constant.colors.length);
        var res = [];
        for (var i = 0; i < count; i++) {
            res = res.concat(_constant.colors);
        }
        return res;
    } else {
        return _constant.colors;
    }
};
var getColorsByIndex = exports.getColorsByIndex = function getColorsByIndex(i) {
    return _constant.colors[i];
};
var getColorsByNum2 = exports.getColorsByNum2 = function getColorsByNum2(num) {
    if (num >= _constant.colors.length) {
        return _constant.colors;
    } else {
        var offset = _constant.colors.length / num; //
        var backI = null;
        var res = [];
        for (var i = 0; i < _constant.colors.length; i) {
            if (res.length >= num) break;
            var index = parseInt(i);
            if (backI != index) {
                res.push(_constant.colors[index]);
                backI = index;
            }
            i = i + offset;
        }
        return res;
    }
};
//取得下拉菜单
var getSelctList = exports.getSelctList = function getSelctList(dataInfo) {
    // 入口cheeck
    var dataList = [];
    if (!dataInfo || !dataInfo.statisticsInfo) {
        return null;
    }
    var colData = dataInfo.statisticsData.colData;
    if (!!colData && colData.length > 0) {
        var value = '';
        for (var i = 0; i < colData.length; i++) {
            var selectOption = {};
            selectOption.key = 'col_' + i + '_';
            selectOption.value = colData[i][0];
            if (i == 0) {
                value = selectOption.key;
            }
            dataList.push(selectOption);
        }
        var option = {
            placeholder: '',
            label: 'value',
            value: 'key',
            width: 200
        };
        return { dataList: dataList, value: value, option: option };
    } else {
        return null;
    }
};
var valueToNumber = function valueToNumber(value, def) {
    if (def !== 0) def = '';
    var res = 1;
    try {
        if (!!value) {
            res = parseFloat(value);
        } else {
            res = def;
        }
    } catch (e) {
        res = 1;
    }
    return res;
};
// 找出最大的n个值，剩余取总// -1：line全部转换启动行头制作，只在第一次循环（index=0）制作
var getMaxData = exports.getMaxData = function getMaxData(inputData, n, columnId, info, index, mode) {
    n = parseInt(n);
    // 排行榜制作
    var topN = [];
    if (!n) {
        return topN;
    }
    var dataInfo = {};
    if (inputData.statisticsData && inputData.statisticsInfo) {
        dataInfo = inputData;
        inputData = inputData.statisticsData.data;
    }
    // 去除计算属性()已经在前文剔除
    // let data = inputData.filter(item => !item.rowType)
    // 字符串补丁总值
    var data = inputData;
    // 启动行头制作
    var topPushItemBackList = [];
    if (n == -1 && index == 0) {
        // 制作头游标
        topPushItemBackList.length = info.rowHeaders.length;
    }
    if (n == -1) {
        for (var i = 0; i < data.length; i++) {
            var item = data[i];
            var topPushItem = {};
            topPushItem.item = item;
            topPushItem.value = valueToNumber(item[columnId][1]);
            topPushItem.lable = item[columnId][0] ? item[columnId][0] : '';
            topPushItem.columnId = columnId;
            //放入队列
            topN.push(topPushItem);
            // 启动行头制作
            if (n == -1 && index == 0) {
                console.log('启动行头制作---');
                topPushItem.rowHeaders = [];
                for (var h = 0; h < info.rowHeaders.length; h++) {
                    var rheader = info.rowHeaders[h];
                    var key = rheader.aliasTableName + '_' + rheader.name;

                    var rowHeaderItem = {};
                    rowHeaderItem.key = key;
                    rowHeaderItem.value = item[key][1];
                    rowHeaderItem.lable = item[key][0];
                    if (h == 0) {
                        rowHeaderItem.map = rowHeaderItem.value;
                    } else {
                        rowHeaderItem.map = topPushItem.rowHeaders[h - 1].map + ',' + rowHeaderItem.value;
                    }
                    // 前置比较
                    if (topPushItemBackList[h]) {
                        if (topPushItemBackList[h].rowHeaders[h].map === rowHeaderItem.map) {
                            rowHeaderItem.colSpan = 0; // 跳过此航头，前置航头+1
                            topPushItemBackList[h].rowHeaders[h].colSpan = topPushItemBackList[h].rowHeaders[h].colSpan + 1;
                        } else {
                            rowHeaderItem.colSpan = 1;
                            topPushItemBackList[h] = topPushItem;
                        }
                    } else {
                        rowHeaderItem.colSpan = 1;
                        topPushItemBackList[h] = topPushItem;
                    }
                    // 加入头
                    topPushItem.rowHeaders.push(rowHeaderItem);
                }

                // 最后缓存
            }
        }
    } else {
        // 垃圾字段回收
        var otherValue = 0;
        // 循环
        for (var _i = 0; _i < data.length; _i++) {
            var _item = data[_i];
            var value = valueToNumber(_item[columnId][1]);

            var lable = _item[columnId][0] ? _item[columnId][0] : '';
            if (mode == 'radar') {
                // 雷达图直接放进去，无需排序
                if (topN.length < n) {
                    var _topPushItem = {};
                    _topPushItem.value = value;
                    _topPushItem.lable = lable;
                    _topPushItem.item = _item;
                    _topPushItem.columnId = columnId;
                    topN.push(_topPushItem);
                } else {
                    break;
                }
            } else {
                //饼图不需要0 的数据
                if (!value) continue;
                //饼图不需要非数字 的数据

                if (topN.length == 0) {
                    var _topPushItem2 = {};
                    _topPushItem2.value = value;
                    _topPushItem2.lable = lable;
                    _topPushItem2.item = _item;
                    _topPushItem2.columnId = columnId;
                    topN.push(_topPushItem2);
                } else {
                    var inFlg = false;
                    for (var j = 0; j < topN.length; j++) {
                        var topItem = topN[j];
                        if (value > topItem.value) {
                            var _topPushItem3 = {};
                            _topPushItem3.value = value;
                            _topPushItem3.lable = lable;
                            _topPushItem3.item = _item;
                            _topPushItem3.columnId = columnId;
                            //加入排行榜
                            inFlg = true;
                            topN.splice(j, 0, _topPushItem3);
                            // 如果超标了就弹出最后一个
                            if (topN.length > n - 1) {
                                var overItem = topN.pop();
                                otherValue = otherValue + overItem.value; //替换垃圾
                            }
                            break;
                        }
                        if (j == topN.length - 1) {
                            if (topN.length < n - 1) {
                                //加入排行榜
                                inFlg = true;
                                var _topPushItem4 = {};
                                _topPushItem4.value = value;
                                _topPushItem4.lable = lable;
                                _topPushItem4.item = _item;
                                _topPushItem4.columnId = columnId;
                                topN.push(_topPushItem4);
                                break;
                            }
                        }
                    }
                    if (!inFlg) otherValue = otherValue + value;
                }
            }
        }
        // 装载其他字段
        if (otherValue > 0) {
            var topOtherItem = {};
            topOtherItem.value = otherValue;
            topOtherItem.lable = '其他';
            topOtherItem.name = '其他';
            topN.push(topOtherItem);
        }
    }
    return topN;
};
// 数据namefilter
// 行头计算
var setRowHeaderName = exports.setRowHeaderName = function setRowHeaderName(topN, info, sum, mode) {
    var _loop = function _loop(i) {
        var topItem = topN[i];
        if (topItem.item) {
            // 取得名字
            var name = '';
            var index = 0;
            info.rowHeaders.forEach(function (item) {
                var key = item.aliasTableName + '_' + item.name;
                if (index === 0) {
                    name = topItem.item[key][0] ? topItem.item[key][0] : '';
                } else {
                    name = name + '/' + (topItem.item[key][0] ? topItem.item[key][0] : '');
                }
                index = index + 1;
            });
            topItem.name = name;
        }
        //if(mode == 'pie'){
        // 取得百分比
        if (!!topItem.value && typeof topItem.value == 'number') {
            var parent = parseInt(topItem.value / sum * 1000);
            var z = parseInt(parent / 10);
            var x = parent % 10;
            parent = z;
            if (x > 0) parent = parent + '.' + x;
            topItem.percent = parent + '%';
        } else {
            topItem.percent = '0%';
        }

        //}
    };

    //
    for (var i = 0; i < topN.length; i++) {
        _loop(i);
    }
    return topN;
};
//穿透配置转换
var penetrationUtil = exports.penetrationUtil = function penetrationUtil(item, userConditions, Data, Info) {
    // 当前行数据
    var currentRow = item.item;
    // 列表头
    var currentCol = {};
    if (Info) {
        for (var _i2 = 0; _i2 < Info.statsFields.length; _i2++) {
            var statsField = Info.statsFields[_i2];
            var diffId = statsField.aliasTableName + '_' + statsField.name;
            if (item.columnId.indexOf(diffId) >= 0) {
                currentCol = statsField;
                break;
            }
        }
    }
    // 穿透配置

    // 左侧分组项
    var rowHeaders = Info.rowHeaders;
    var rowData = {},
        colData,
        title = "";
    for (var i = 0; i < rowHeaders.length; i++) {
        var header = rowHeaders[i];
        var key = header.aliasTableName + "_" + header.name;
        rowData[key] = currentRow[key][1];
        title = title + (currentRow[key][0] == undefined ? "" : currentRow[key][0]) + "_";
    }
    var thisKey = item.columnId;

    if (!!Data.colData && Data.colData.length > 0) {
        //有交叉项
        var colIndex = item.columnId.substring(4, item.columnId.indexOf('_', 4));
        //当前的交叉
        var currentCross = Data.colData[colIndex];
        colData = currentCross[1];
        title = title + (currentCross[0] == undefined ? "" : currentCross[0]) + "_";
    }
    title = title + currentCol.aliasDisplay;
    if (currentCol.calcType == "sum") {
        title = title + "(求和)";
    } else if (currentCol.calcType == "count") {
        title = title + "(计数)";
    } else if (currentCol.calcType == "avg") {
        title = title + "(平均值)";
    } else if (currentCol.calcType == "max") {
        title = title + "(最大值)";
    } else if (currentCol.calcType == "min") {
        title = title + "(最小值)";
    }
    var title2 = currentRow[thisKey][0];
    // if(!!title)title = escapeStringToHTML(title,true,false);
    // if(!!title2)title2 = escapeStringToHTML(title2,true,false);

    var statisticItem = currentCol;
    var params = {
        Info: Info,
        rowData: rowData,
        colData: colData,
        userConditions: userConditions,
        statisticItem: statisticItem
        // windows绑定
    };var statisticsPopData = { title: title, title2: title2, params: params };
    return statisticsPopData;
};
// 取得地址上参数
var getUrlParam = exports.getUrlParam = function getUrlParam(name) {
    var reg = new RegExp("(^|&|#|/?)" + name + "=([^&]*)(&|$)", "i");
    var r = window.location.href.substr(1).match(reg);
    if (r != null) {
        var result = unescape(r[2]);
        if (result.indexOf('#') > 0) {
            result = result.slice(0, result.indexOf('#'));
        };
        return result;
    }
    return null;
};
// 取得地址上参数
var getUrlParamXms = exports.getUrlParamXms = function getUrlParamXms(name) {
    var reg = new RegExp("(^|&|#|/?)" + name + "=([^&]*)(&|$)", "i");
    var r = window.location.href.substr(1).match(reg);
    if (r != null) {
        var result = decodeURI(r[2]);
        if (result.indexOf('#') > 0) {
            result = result.slice(0, result.indexOf('#'));
        };
        return result;
    }
    return null;
};