'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.penetrationUtil = exports.setRowHeaderName = exports.getMaxData = exports.getSelctList = exports.getColorsByNum2 = exports.getColorsByIndex = exports.getColorsByNum = exports.dataFilter = exports.dateFormat = exports.dataToEchartData = exports.createDataItemToEchartDataInfo = exports.createEchartData = exports.configureSpecialUrl = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _constant = require('./constant.js');

var _moneyFormat = require('./moneyFormat.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// title设置 屏蔽名单
/*eslint-disable*/
var configureSpecialUrl = exports.configureSpecialUrl = [{ urlFileds: 'main.do' }, { urlFileds: 'business.do' }, { urlFileds: 'businessTemplateController.do' }, { urlFileds: 'vReport.do' }];

// dataInfo 统计的数据包，根据 selectGroup,selectIndex提取数据
// selectGroup 交叉表的交叉表头
// selectIndex 选择的列
// option:
// option.max Number 最大行，默认为-1，不限制
// option.hansLastData  Boolean 是否存在合计行，默认：true
// option.mode String 根据echart命名，echart类型名 默认：''

var echartDataDefaultOption = {
    max: -1,
    hansLastData: true,
    mode: ''
};

var createEchartData = exports.createEchartData = function createEchartData(dataInfo, selectGroup, selectIndex, option) {
    var useDataInfos = [];

    if (!dataInfo || !dataInfo.statisticsInfo) return useDataInfos;
    option = (0, _assign2.default)(echartDataDefaultOption, option);

    if (option.hansLastData) dataFilter(dataInfo, option); // 剔除计算属性取得lastData

    if (selectIndex >= 0) {
        var item = dataInfo.statisticsInfo.statsFields[selectIndex];
        option.selectIndex = selectIndex;
        var echartDataInfo = createDataItemToEchartDataInfo(dataInfo, item, selectGroup, option);
        useDataInfos.push(echartDataInfo);
    } else {
        for (var i = 0; i < dataInfo.statisticsInfo.statsFields.length; i++) {
            var _item = dataInfo.statisticsInfo.statsFields[i];
            option.selectIndex = i;
            var _echartDataInfo = createDataItemToEchartDataInfo(dataInfo, _item, selectGroup, option);
            useDataInfos.push(_echartDataInfo);
        }
    }
    return useDataInfos;
};

// 解析出带交叉的表头
var createDataItemToEchartDataInfo = exports.createDataItemToEchartDataInfo = function createDataItemToEchartDataInfo(dataInfo, item, selectGroup, option) {
    var columnId = '';
    if (selectGroup) {
        columnId = '' + selectGroup + item.aliasTableName + '_' + item.name;
    } else {
        columnId = item.aliasTableName + '_' + item.name;
    }
    // 构造echart数据
    var echartDataInfo = dataToEchartData(dataInfo, columnId, option, item);
    echartDataInfo.penetrateEnable = item.penetrateEnable;
    echartDataInfo.statsField = item;
    echartDataInfo.key = columnId;
    echartDataInfo.lastData = dataInfo.statisticsData.lastData;
    echartDataInfo.columnName = item.aliasDisplay;
    return echartDataInfo;
};

// 通用数据解析清单
var dataToEchartData = exports.dataToEchartData = function dataToEchartData(dataInfo, columnId, option, statsField) {
    var res = {};
    res.value = '';
    var data = dataInfo.statisticsData.data;
    var info = dataInfo.statisticsInfo;
    // 取出合计项
    // (inputData, n, columnId, info, index, mode,statsField)
    // 合计的情况 弹出合计项；
    var topN = getMaxData(dataInfo, option.max, columnId, info, option.selectIndex, option.mode, statsField);

    // 合计值
    var lastData = dataInfo.statisticsData.lastData;
    if (lastData && lastData[columnId]) {
        var sum = lastData[columnId][1];
        res.info = { sum: sum };
        res.data = setRowHeaderName(topN, info, sum);
    } else {
        res.info = { sum: 0 };
        res.data = setRowHeaderName(topN, info);
    }
    //  取得轮盘颜色
    var numColors = getColorsByNum(res.data.length);
    for (var i = 0; i < res.data.length; i++) {
        var item = res.data[i];
        item.capIndex = i;
        item.itemStyle = { normal: { color: numColors[i] } };
    }
    return res;
};

// 日期格式化
var dateFormat = exports.dateFormat = function dateFormat(data, fmt) {
    if (!fmt) fmt = "yyyy-MM-dd hh:mm:ss";
    var o = {
        "M+": data.getMonth() + 1, //月份
        "d+": data.getDate(), //日
        "h+": data.getHours(), //小时
        "m+": data.getMinutes(), //分
        "s+": data.getSeconds(), //秒
        "q+": Math.floor((data.getMonth() + 3) / 3), //季度
        "S": data.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) {
        fmt = fmt.replace(RegExp.$1, (data.getFullYear() + "").substr(4 - RegExp.$1.length));
    }
    for (var k in o) {
        if (new RegExp("(" + k + ")").test(fmt)) {
            fmt = fmt.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
        }
    }
    return fmt;
};
// 剔除计算属性，取得lastData
var dataFilter = exports.dataFilter = function dataFilter(dataInfo, option) {
    if (dataInfo.statisticsData.lastData) {
        return dataInfo;
    }
    if (dataInfo && dataInfo.statisticsData.data && dataInfo.statisticsData.data.length) {
        var lastData = dataInfo.statisticsData.data[dataInfo.statisticsData.data.length - 1];
        if (lastData.rowType === '1') {
            dataInfo.statisticsData.lastData = lastData;
            dataInfo.statisticsData.data = dataInfo.statisticsData.data.filter(function (item) {
                return !item.rowType;
            });
        } else {
            // 自己计算
            var comLastData = {};
            for (var i = 0; i < dataInfo.statisticsData.data.length; i++) {
                var item = dataInfo.statisticsData.data[i];
                for (var arr in item) {
                    if (item[arr] && (0, _typeof3.default)(item[arr]) == 'object') {
                        if (!!comLastData[arr]) {
                            comLastData[arr][0] = comLastData[arr][1] = comLastData[arr][1] + valueToNumber(item[arr][1], 0);
                        } else {
                            comLastData[arr] = [0, 0];
                            comLastData[arr][0] = comLastData[arr][1] = comLastData[arr][1] + valueToNumber(item[arr][1], 0);
                        }
                    }
                }
            }
            dataInfo.statisticsData.lastData = comLastData;
        }
    }
    return dataInfo;
};

// 轮盘取色器
var getColorsByNum = exports.getColorsByNum = function getColorsByNum(num) {
    if (num > _constant.colors.length) {
        var count = Math.ceil(num / _constant.colors.length);
        var res = [];
        for (var i = 0; i < count; i++) {
            res = res.concat(_constant.colors);
        }
        return res;
    } else {
        return _constant.colors;
    }
};
var getColorsByIndex = exports.getColorsByIndex = function getColorsByIndex(i) {
    var ci = i % 20;
    return _constant.colors[ci];
};
var getColorsByNum2 = exports.getColorsByNum2 = function getColorsByNum2(num) {
    if (num >= _constant.colors.length) {
        return _constant.colors;
    } else {
        var offset = _constant.colors.length / num; //
        var backI = null;
        var res = [];
        for (var i = 0; i < _constant.colors.length; i) {
            if (res.length >= num) break;
            var index = parseInt(i);
            if (backI != index) {
                res.push(_constant.colors[index]);
                backI = index;
            }
            i = i + offset;
        }
        return res;
    }
};
//取得下拉菜单
var getSelctList = exports.getSelctList = function getSelctList(dataInfo) {

    // 入口cheeck
    var dataList = [];
    if (!dataInfo || !dataInfo.statisticsInfo) {
        return null;
    }
    var colData = dataInfo.statisticsData.colData;
    if (!!colData && colData.length > 0) {
        var value = '';
        for (var i = 0; i < colData.length; i++) {
            var selectOption = {};
            selectOption.key = 'col_' + i + '_';
            selectOption.value = colData[i] ? colData[i][0] : '';
            if (i == 0) {
                value = selectOption.key;
            }
            dataList.push(selectOption);
        }
        var option = {
            placeholder: '',
            label: 'value',
            value: 'key',
            width: 200
        };
        return { dataList: dataList, value: value, option: option };
    } else {
        return null;
    }
};
var valueToNumber = function valueToNumber(value, def) {
    if (def !== 0) def = '';
    var res = 0;
    try {
        var re = /^(\-|\+)?\d+(\.\d+)?$/;
        if (re.test(value)) {
            value = parseFloat(value);
            if (typeof value == 'number') {
                res = value;
            } else {
                res = def;
            }
        }
    } catch (e) {
        res = def;
    }
    return res;
};
var makeLable = function makeLable(item, columnId) {};
// 找出最大的n个值，剩余取总// -1：line全部转换启动行头制作，只在第一次循环（index=0）制作
var getMaxData = exports.getMaxData = function getMaxData(inputData, n, columnId, info, index, mode, statsField) {
    n = parseInt(n);
    // 排行榜制作
    var topN = [];
    if (!n) {
        return topN;
    }

    var dataInfo = {};
    if (inputData.statisticsData && inputData.statisticsInfo) {
        dataInfo = inputData;
        inputData = inputData.statisticsData.data;
    }
    // 去除计算属性()已经在前文剔除
    // let data = inputData.filter(item => !item.rowType)
    // 字符串补丁总值

    var data = inputData;
    // 启动行头制作
    var topPushItemBackList = [];
    if (n == -1 && index == 0) {
        // 制作头游标
        topPushItemBackList.length = info.rowHeaders.length;
    }
    if (n == -1) {
        for (var i = 0; i < data.length; i++) {
            var item = data[i];
            var topPushItem = {};
            topPushItem.item = item;
            topPushItem.value = valueToNumber(item[columnId][1]);
            topPushItem.lable = item[columnId][0] ? item[columnId][0] : '';
            topPushItem.columnId = columnId;
            //放入队列
            topN.push(topPushItem);
            // 启动行头制作
            if (n == -1 && index == 0) {
                topPushItem.rowHeaders = [];
                for (var h = 0; h < info.rowHeaders.length; h++) {
                    var rheader = info.rowHeaders[h];
                    var key = rheader.aliasTableName + '_' + rheader.name;

                    var rowHeaderItem = {};
                    rowHeaderItem.key = key;
                    rowHeaderItem.value = item[key][1];
                    rowHeaderItem.lable = item[key][0];
                    if (h == 0) {
                        rowHeaderItem.map = rowHeaderItem.value;
                    } else {
                        rowHeaderItem.map = topPushItem.rowHeaders[h - 1].map + ',' + rowHeaderItem.value;
                    }
                    // 前置比较
                    if (topPushItemBackList[h]) {
                        if (topPushItemBackList[h].rowHeaders[h].map === rowHeaderItem.map) {
                            rowHeaderItem.colSpan = 0; // 跳过此航头，前置航头+1
                            topPushItemBackList[h].rowHeaders[h].colSpan = topPushItemBackList[h].rowHeaders[h].colSpan + 1;
                        } else {
                            rowHeaderItem.colSpan = 1;
                            topPushItemBackList[h] = topPushItem;
                        }
                    } else {
                        rowHeaderItem.colSpan = 1;
                        topPushItemBackList[h] = topPushItem;
                    }
                    // 加入头
                    topPushItem.rowHeaders.push(rowHeaderItem);
                }

                // 最后缓存
            }
        }
    } else {
        // 垃圾字段回收
        var otherValue = 0;
        // 循环
        for (var _i = 0; _i < data.length; _i++) {
            var _item2 = data[_i];
            var value = valueToNumber(_item2[columnId][1]);
            var lable = _item2[columnId][0] ? _item2[columnId][0] : '';
            if (mode == 'radar') {
                // 雷达图直接放进去，无需排序
                if (topN.length < n) {
                    var _topPushItem = {};
                    _topPushItem.value = value;
                    _topPushItem.lable = lable;
                    _topPushItem.item = _item2;
                    _topPushItem.columnId = columnId;
                    topN.push(_topPushItem);
                } else {
                    break;
                }
            } else {
                //饼图不需要0 的数据
                if (!value) continue;
                //饼图不需要非数字 的数据

                if (topN.length == 0) {
                    var _topPushItem2 = {};
                    _topPushItem2.value = value;
                    _topPushItem2.lable = lable;
                    _topPushItem2.item = _item2;
                    _topPushItem2.columnId = columnId;
                    topN.push(_topPushItem2);
                } else {
                    var inFlg = false;
                    for (var j = 0; j < topN.length; j++) {
                        var topItem = topN[j];
                        if (value > topItem.value) {
                            var _topPushItem3 = {};
                            _topPushItem3.value = value;
                            _topPushItem3.lable = lable;
                            _topPushItem3.item = _item2;
                            _topPushItem3.columnId = columnId;
                            //加入排行榜
                            inFlg = true;
                            topN.splice(j, 0, _topPushItem3);
                            // 如果超标了就弹出最后一个
                            if (topN.length > n - 1) {
                                var overItem = topN.pop();
                                otherValue = otherValue + overItem.value; //替换垃圾
                            }
                            break;
                        }
                        if (j == topN.length - 1) {
                            if (topN.length < n - 1) {
                                //加入排行榜
                                inFlg = true;
                                var _topPushItem4 = {};
                                _topPushItem4.value = value;
                                _topPushItem4.lable = lable;
                                _topPushItem4.item = _item2;
                                _topPushItem4.columnId = columnId;
                                topN.push(_topPushItem4);
                                break;
                            }
                        }
                    }
                    if (!inFlg) otherValue = otherValue + value;
                }
            }
        }
        // 装载其他字段
        if (otherValue > 0) {
            var topOtherItem = {};
            topOtherItem.value = otherValue;
            topOtherItem.lable = fomatAsServer(otherValue, statsField);
            topOtherItem.itemKey = '其他';
            topOtherItem.name = '其他';
            topN.push(topOtherItem);
        }
    }
    return topN;
};
// 跟后端同步转换
var fomatAsServer = function fomatAsServer(value, statsField) {
    if (value !== 0 && !value) return 0;
    // 小数位
    var digitNum = statsField.digitNum ? parseInt(statsField.digitNum) : 0;
    // has千分位 format_thousand 百分位format_hundred
    // 是否是百分比
    var format_hundred = statsField.formatType ? statsField.formatType.indexOf('format_hundred') >= 0 : false;
    var format_thousand = statsField.formatType ? statsField.formatType.indexOf('format_thousand') >= 0 : false;

    if (format_hundred) {
        value = value * 100;
    }
    if (digitNum > 0) {
        value = (0, _moneyFormat.moneyDecimal)(value, digitNum, 1);
    }
    if (format_thousand) {
        value = (0, _moneyFormat.formatThousand)(value);
    }
    if (format_hundred) {
        value = value + '%';
    }
    return value;
};

// 数据namefilter
//行头计算
var setRowHeaderName = exports.setRowHeaderName = function setRowHeaderName(topN, info, sum) {
    // 所有百分比的和值
    var allPercent = 0;
    var percentList = [];

    var _loop = function _loop(i) {
        var topItem = topN[i];
        if (topItem.item) {
            // 取得名字
            var name = '';
            var itemKey = '';
            var index = 0;
            info.rowHeaders.forEach(function (item) {
                var key = item.aliasTableName + '_' + item.name;
                var subName = '';
                var subItemKey = '';
                if (topItem.item[key][0] == null) {
                    subName = 'null';
                    subItemKey = '';
                } else {
                    subName = topItem.item[key][0] ? topItem.item[key][0] : '';
                    subItemKey = topItem.item[key][0] ? topItem.item[key][0] : '';
                }

                if (index === 0) {
                    name = subName;
                    itemKey = subItemKey;
                } else {
                    name = name + '/' + subName;
                    itemKey = itemKey + '/' + subItemKey;
                }
                index = index + 1;
            });
            topItem.name = name;
            topItem.itemKey = itemKey;
        }
        if (sum && sum > 0) {
            // 取得百分比
            // let allPercent = 0;
            var sumNumber = valueToNumber(sum);

            // topItem.value = 11;
            if (!!sumNumber && sumNumber > 0) {
                var parentS = topItem.value / sumNumber;
                var parentF = parseFloat(parentS.toFixed(3));
                allPercent = allPercent + parentF;
                var sortList = { index: i, value: parentF - parentS, parentS: parentS, parentF: parentF };
                percentList.push(sortList);

                //
                // let parent = Math.floor(topItem.value / sumNumber * 1000);
                // const z = parseInt(parent/10);
                // const x = (parent % 10);
                // parent = z;
                // if(x>0)parent = parent +'.'+ x;
                // topItem.percent = parent + '%';
            }
        }
    };

    for (var i = 0; i < topN.length; i++) {
        _loop(i);
    }
    if (allPercent > 0) {

        // 取得差点 如果大于100%
        if (allPercent > 1) {
            // 值降序
            percentList = percentList.sort(function (a, b) {
                return b.value - a.value;
            });
            // 取得差多少
            var count = parseInt((allPercent - 1) / 0.001);
            for (var p = 0; p <= count - 1; p++) {
                percentList[p].parentF = percentList[p].parentF - 0.001;
            }
            // index 升序
            percentList = percentList.sort(function (a, b) {
                return a.index - b.index;
            });
        }
        // 再一次循环
        for (var i = 0; i < topN.length; i++) {
            var _topItem = topN[i];
            var overPercent = (percentList[i].parentF * 100).toFixed(1);
            _topItem.realPercent = parseFloat(overPercent);
            _topItem.percent = overPercent + '%';
        }
    }

    return topN;
};

//穿透配置转换
var penetrationUtil = exports.penetrationUtil = function penetrationUtil(item, designId, userConditions, Data, Info) {
    // 当前行数据
    var currentRow = item.item;
    // 列表头
    var currentCol = {};
    if (Info) {
        for (var _i2 = 0; _i2 < Info.statsFields.length; _i2++) {
            var statsField = Info.statsFields[_i2];
            var diffId = statsField.aliasTableName + '_' + statsField.name;
            if (item.columnId.indexOf(diffId) >= 0) {
                currentCol = statsField;
                break;
            }
        }
    }
    // 穿透配置

    // 左侧分组项
    var rowHeaders = Info.rowHeaders;
    var rowData = {},
        colData,
        title = "";
    for (var i = 0; i < rowHeaders.length; i++) {
        var header = rowHeaders[i];
        var key = header.aliasTableName + "_" + header.name;
        rowData[key] = currentRow[key][1];
        title = title + (currentRow[key][0] == undefined ? "" : currentRow[key][0]) + "_";
    }
    var thisKey = item.columnId;

    if (!!Data.colData && Data.colData.length > 0) {
        //有交叉项
        var colIndex = item.columnId.substring(4, item.columnId.indexOf('_', 4));
        //当前的交叉
        var currentCross = Data.colData[colIndex] ? Data.colData[colIndex] : ['', ''];
        colData = currentCross[1];
        title = title + (currentCross[0] == undefined ? "" : currentCross[0]) + "_";
    }
    title = title + currentCol.aliasDisplay;
    if (currentCol.calcType == "sum") {
        title = title + "(求和)";
    } else if (currentCol.calcType == "count") {
        title = title + "(计数)";
    } else if (currentCol.calcType == "avg") {
        title = title + "(平均值)";
    } else if (currentCol.calcType == "max") {
        title = title + "(最大值)";
    } else if (currentCol.calcType == "min") {
        title = title + "(最小值)";
    }
    title = title + ":" + (currentRow[thisKey][0] ? currentRow[thisKey][0] : '');
    if (!!title) title = escapeStringToHTML(title, true, false);
    var statisticItem = currentCol;
    var params = {
        designId: designId,
        rowData: rowData,
        colData: colData,
        userConditions: userConditions,
        statisticItem: statisticItem
    };
    var url = _ctxPath + "/report4Result.do?method=reportPenetrate&rptDesignId=" + designId + "&statisticItem=" + encodeURI((0, _stringify2.default)(currentCol));
    // windows绑定
    var statisticsPopData = { url: url, title: title, params: params };
    window.top.getStatisticsPopParams = function () {
        return statisticsPopData;
    };
    return statisticsPopData;
};