import Cap4Condition from './src/cap4-condition';
import Cap4ConditionMain from './src/cap4-condition-main';
import Cap4ConditionSenior from './src/cap4-condition-senior';


const components = [Cap4Condition,Cap4ConditionMain,Cap4ConditionSenior];

for(let i=0;i<components.length;i++){
  let component = components[i];
  component.install = function (Vue) {
    Vue.component(component.name, component);
  };
}

const install = function(Vue) {
  if (install.installed) return;
  components.map(component => component.install(Vue))
}

export default  {
  install,
  Cap4Condition,
  Cap4ConditionMain,
  Cap4ConditionSenior
}
