const formatdate = (function() {
    const formatDateApi = function() {
        this.now = new Date();                    //当前日期
        this.nowDayOfWeek = this.now.getDay();         //今天本周的第几天
        this.nowDay = this.now.getDate();              //当前日
        this.nowMonth = this.now.getMonth();           //当前月
        this.nowYear = this.now.getYear();             //当前年
        this.nowYear += (this.nowYear < 2000) ? 1900 : 0;  //
        this.lastMonthDate = new Date();  //上月日期
        this.lastMonthDate.setDate(1);
        this.lastMonthDate.setMonth(this.lastMonthDate.getMonth() - 1);
        this.lastYear = this.lastMonthDate.getYear();
        this.lastMonth = this.lastMonthDate.getMonth();
        this.startMonth=this.getWeekStartDate();
    };
    formatDateApi.prototype.formatDate=function(date) {
        let myyear = date.getFullYear();
        let mymonth = date.getMonth() + 1;
        let myweekday = date.getDate();

        if (mymonth < 10) {
            mymonth = "0" + mymonth;
        }
        if (myweekday < 10) {
            myweekday = "0" + myweekday;
        }
        return (myyear + "-" + mymonth + "-" + myweekday);
    };

    formatDateApi.prototype.getMonthDays=function(myMonth) {
        let monthStartDate = new Date(this.nowYear, myMonth, 1);
        let monthEndDate = new Date(this.nowYear, myMonth + 1, 1);
        let days = (monthEndDate - monthStartDate) / (1000 * 60 * 60 * 24);
        return days;
    };

    formatDateApi.prototype.getQuarterStartMonth=function() {
        let quarterStartMonth = 0;
        if (this.nowMonth < 3) {
            quarterStartMonth = 0;
        }
        if (2 < this.nowMonth && this.nowMonth < 6) {
            quarterStartMonth = 3;
        }
        if (5 < this.nowMonth && this.nowMonth < 9) {
            quarterStartMonth = 6;
        }
        if (this.nowMonth > 8) {
            quarterStartMonth = 9;
        }
        return quarterStartMonth;
    };
    formatDateApi.prototype.getThisDate=function() {
        let weekStartDate = new Date(this.nowYear, this.nowMonth, this.nowDay);
        return this.formatDate(weekStartDate);
    };

    formatDateApi.prototype.getWeekStartDate=function() {
        let weekStartDate = new Date(this.nowYear, this.nowMonth, this.nowDay +1 - this.nowDayOfWeek);
        return this.formatDate(weekStartDate);
    };

    formatDateApi.prototype.getWeekEndDate=function() {
        let weekEndDate = new Date(this.nowYear, this.nowMonth, this.nowDay + (+7 - this.nowDayOfWeek));
        return this.formatDate(weekEndDate);
    };
    formatDateApi.prototype.getYearStartDate=function() {
        let monthStartDate = new Date(this.nowYear, 0, 1);
        return this.formatDate(monthStartDate);
    };
    formatDateApi.prototype.getYearEndDate=function() {
        let monthStartDate = new Date(this.nowYear, 11, 31);
        return this.formatDate(monthStartDate);
    };

    formatDateApi.prototype.getMonthStartDate=function() {
        let monthStartDate = new Date(this.nowYear, this.nowMonth, 1);
        return this.formatDate(monthStartDate);
    };

    formatDateApi.prototype.getMonthEndDate=function() {
        let monthEndDate = new Date(this.nowYear, this.nowMonth, this.getMonthDays(this.nowMonth));
        return this.formatDate(monthEndDate);
    };

    formatDateApi.prototype.getLastMonthStartDate=function() {
        let lastMonthStartDate = new Date(this.nowYear, this.lastMonth, 1);
        return this.formatDate(lastMonthStartDate);
    };

    formatDateApi.prototype.getLastMonthEndDate=function() {
        let lastMonthEndDate = new Date(this.nowYear, this.lastMonth, this.getMonthDays(this.lastMonth));
        return this.formatDate(lastMonthEndDate);
    };

    formatDateApi.prototype.getQuarterStartDate=function() {
        let quarterStartDate = new Date(this.nowYear, this.getQuarterStartMonth(), 1);
        return this.formatDate(quarterStartDate);
    };

    formatDateApi.prototype.getQuarterEndDate=function() {
        let quarterEndMonth = this.getQuarterStartMonth() + 2;
        let quarterStartDate = new Date(this.nowYear, quarterEndMonth, this.getMonthDays(quarterEndMonth));
        return this.formatDate(quarterStartDate);
    };
    return new formatDateApi();
});
export {
    formatdate
}