/*eslint-disable*/
export const canvasDraw  = (ctx,circle) => {
    ctx.beginPath();
    ctx.arc(circle.centerX, circle.centerY, circle.radius, 0, Math.PI*2, true);  // 坐标为250的圆，这里起始角度是0，结束角度是Math.PI*2
    ctx.lineWidth = circle.lineWidth;
    ctx.strokeStyle = circle.strokeStyle;

    ctx.stroke();  // 这里用stroke画一个空心圆，想填充颜色的童鞋可以用fill方法
}
//画结束小圆点
export const canvasDrawStart  = (ctx,point,animationParams) => {
  ctx.beginPath();
  ctx.strokeStyle = point.strokeStyle;
  ctx.shadowColor = point.shadowColor;
  ctx.shadowBlur = point.shadowBlur;
  // 取得外环半径
  let padding = animationParams.context.padding;
  let radius = animationParams.context.radius;
  let nowP =animationParams.nowp>100?360: animationParams.nowp * 3.6;
  let h = padding;
  let x = padding + radius;

  if(nowP <= 90){
    var radian = nowP * Math.PI / 180;
    x = x + Math.sin(radian) * radius;
    h = h + radius - Math.cos(radian) * radius;
  }
  if(nowP > 90 && nowP <= 180){
    var radian = (nowP - 90) * Math.PI / 180;
    x = x + Math.cos(radian) * radius;
    h = h + radius + Math.sin(radian) * radius;
  }
  if(nowP > 180 && nowP <= 270){
    var radian = (nowP - 180) * Math.PI / 180;
    x = x - Math.sin(radian) * radius;
    h = h + (radius + Math.cos(radian) * radius);
  }
  if(nowP > 270){
    var radian = (nowP - 270) * Math.PI / 180;
    x = x - Math.cos(radian) * radius;
    h = h + (radius - Math.sin(radian) * radius);
  }

  ctx.arc(x, h, point.radius, 0, Math.PI*2, true);  // 坐标为250的圆，这里起始角度是0，结束角度是Math.PI*2
  ctx.fillStyle=point.fillStyle;
  ctx.fill();
  ctx.stroke();
}

function clearCanvas(canvas)
{
  var cxt=canvas.getContext("2d");
  cxt.shadowBlur = 0;
  cxt.clearRect(0,0,canvas.width,canvas.height);
}
const animationParams = {
  canvas:null,
  title:'',
  p:0,
  nowp:0,
  animation:true
}

export const canvasAnimation  = (canvas,title,p,context) => {
    animationParams.canvas =canvas;
    animationParams.title =title;
    animationParams.p = p;
    animationParams.nowp = 0;
    animationParams.animation = context.animation;
    animationParams.font = context.font;
    animationParams.circle = context.circle;
    animationParams.point = context.point;
    animationParams.ring = context.ring;
    animationParams.context = context;
    if(!window.requestAnimationFrame){
      window.requestAnimationFrame = (
        window.webkitRequestAnimationFrame ||
        window.mozRequestAnimationFrame ||
        window.msRquestAniamtionFrame ||
        window.oRequestAnimationFrame ||
        function (callback){
          return setTimeout(callback,Math.floor(1000/60))
        }
      )
    }
    window.requestAnimationFrame(canvasAnimationRing);
    //canvasAnimationRing();
}

const canvasAnimationRing  = () => {
  if(animationParams.nowp>animationParams.p){
    return;
  }
  // 第一次加载
  if(animationParams.nowp == 0){

  }
  // 关闭动画
  if(!animationParams.animation){
     animationParams.nowp = animationParams.p
  }
  if(animationParams.nowp > 100){
    animationParams.nowp = animationParams.p
  }
  clearCanvas(animationParams.canvas);
  var ctx =  animationParams.canvas.getContext('2d');
  ctx.beginPath();
  ctx.textAlign="center";
  ctx.font=animationParams.font.titleStyle;
  ctx.fillStyle = animationParams.font.fontColor;

  ctx.fillText(animationParams.title,animationParams.context.size/2,animationParams.context.size/2 - 20);
  // ctx.fillText(animationParams.subTitle,65,57);

  ctx.font=animationParams.font.percentStyle;

  if(animationParams.font.fontGradient && animationParams.font.fontGradient.length == 2){
    var gradient = ctx.createLinearGradient(0, animationParams.context.size/2, 0, animationParams.context.size/2 + 20);
    gradient.addColorStop('0',animationParams.font.fontGradient[0]);
    gradient.addColorStop('1',animationParams.font.fontGradient[1]);
    ctx.fillStyle = gradient;
  }
  ctx.fillText(animationParams.nowp+"%",animationParams.context.size/2,animationParams.context.size/2 + 20);
  canvasDraw(ctx,animationParams.circle);
  //起始小圆
  canvasDrawStart(ctx,animationParams.point,animationParams);

  // angle
  var rp = animationParams.nowp>=100?99:animationParams.nowp;
  ctx.beginPath();
  var anglePerSec = 2 * Math.PI / (100 / animationParams.ring.percent); // 蓝色的弧度
  animationParams.ring.endAngle = ((1.5 + rp*2/100)%2)*Math.PI;
  // ctx.shadowOffsetX = 3;
  // ctx.shadowOffsetY = 3;
  ctx.shadowColor = 'rgba(255,255,255,0.8)';
  ctx.shadowBlur = 8;
  ctx.arc(animationParams.ring.centerX, animationParams.ring.centerY, animationParams.ring.radius, animationParams.ring.startAngle, animationParams.ring.endAngle, false); //这里的圆心坐标要和cirle的保持一致
  ctx.strokeStyle = animationParams.ring.fillStyle;
  ctx.lineCap = animationParams.ring.lineCap;
  ctx.stroke();
  ctx.closePath();

  animationParams.nowp=animationParams.nowp+1;
  if( animationParams.nowp <= animationParams.p){
    window.requestAnimationFrame(canvasAnimationRing);
  }
}
