import {funnelOption} from  './option-funnel'
import deepClone from '_utils/statistics/deepClone';

let valueFormatFun =  function (value,ctx,cellWidth) {
  let res = '';
  // value = '123sasfasdf阿斯顿发送到发生送123sasfasdf阿123sasfasdf阿斯顿发送到发生送送到发生送到发生到发生送到发生斯顿发送到发生送送到发生送到发生到发生送到发生送到发生送到发生到发生送到发生';
  let subMaxDeep = 0;
  if(value){
    let strArray = (value+'').split('');
    let subStr = '';

    for(var i=0;i<strArray.length;i++){
      subStr = subStr + strArray[i];
      if( ctx.measureText(subStr).width > cellWidth - 25){
        if(!res){
          res = subStr
        }else{
          subMaxDeep++;
          res = res + '\n'+subStr
        }
        subStr = '';
        if(subMaxDeep == 2){
          res = res.substring(0,res.length - 1)+'...';
          break;
        }
      }
    }
    if(!!subStr){
      if(!res){
        res = subStr
      }else{
        subMaxDeep++;
        res = res + '\n'+subStr
      }
    }
    return {res,subMaxDeep};
  }else{
    return {res,subMaxDeep};
  }
};

// 数据解析
export const dataToEchartOption = (createEchartData,context) => {
  let option = deepClone(funnelOption);
  let canvas = document.createElement('canvas')//首先创建一个canvas标签
  let ctx = canvas.getContext("2d");//把canvas的画笔给调出来
  ctx.font="12px sans-serif";

  // 如果哟自定义配置，则合并
  if(context.option){
    option.series[0] = Object.assign(option.series[0],context.option)
  }

  option.series[0].label.normal.formatter = (params)=>{
    return valueFormatFun(params.data.itemKey,ctx,context.leftWidth).res
  }

  option.series[0].data = createEchartData[0].data;
  return option;
};



