/*eslint-disable*/

export default {
    props: {
        platform: {
            type: Number, //1pc 2手机
            default: 1
        },
        size: {
            type: Number,
            default: 0
        },
        height: {
            type: Number,
            default: 0
        },
        width: {
            type: Number,
            default: 0
        },
        selectGroup:{
            type: String,
            default: ''
        },
        dataInfo : Object,
        echartDataInfo : {
          default: null
        }
    },
    data() {
        return {
            runFirst:true,
            myChart : null,
            useDataInfos:null,
            selectGroupNow:this.selectGroup
        };
    },
    computed: {
        maxCanvasWidth(){
            if(this.platform == 2){
                return 7000;
            }else{
                return 30000;
            }
        },
        sizeStyle() {
            let sizeStyle = {};
            sizeStyle.height = '100%';
            sizeStyle.width = '100%';
            if (this.size) {
                sizeStyle.height = this.size + 'px';
                sizeStyle.width = this.size + 'px';
            }
            if (this.height) sizeStyle.height = this.height + 'px';
            if (this.width) sizeStyle.width = this.width + 'px';

            return sizeStyle;
        }
    },
    methods: {
        autoCreateEchart(){
            // console.log(this.selectGroup);
            if(this.dataInfo){
                this.selectGroupNow = '';
                // 解析出第一交叉
                if(!this.selectGroup){
                    if(this.dataInfo && this.dataInfo.statisticsInfo && this.dataInfo.statisticsData){
                        let colData = this.dataInfo.statisticsData.colData;
                        if(!!colData && colData.length>0){
                            this.selectGroupNow = `col_0_`;
                        }
                    }
                }else{
                    this.selectGroupNow = this.selectGroup;
                }

                if(this.createData)this.createData(this.dataInfo);
            }else if(this.echartDataInfo){
                this.useDataInfos = this.echartDataInfo;
                if(this.createEchart)this.createEchart(this.echartDataInfo);
            }
        },
        cleanEchart(){
            if(this.myChart){
                // 基于准备好的dom，初始化echarts实例
                this.myChart.clear();
            }
        }
    },
    watch: {
        'dataInfo': {
            handler:function (newVal) {
                this.$nextTick(()=>{
                    this.autoCreateEchart();
                });
            },
            deep: false
        },
        'echartDataInfo': {
            handler:function (newVal) {
                this.$nextTick(()=>{
                    this.autoCreateEchart();
                });
            },
            deep: false
        },
        'selectGroup': {
            handler:function (newVal) {
                if(this.runFirst){
                    this.runFirst = false;
                }else{
                    this.$nextTick(()=>{
                        this.autoCreateEchart();
                    });
                }
            },
            deep: false
        }
    }
}
