/*eslint-disable*/
import {getColorsByIndex,getMaxData,setRowHeaderName} from '_utils/statistics/commonUtil.js';

export {dataFilter,getSelctList} from '_utils/statistics/commonUtil.js';

// 数据解析
export const dataToEchartData = (dataInfo, columnId, index) => {
    //test
    // columnId = 'col_0_formmain_0084_field0004';
    //---------------------------------------
    // 入口cheeck
    if (!dataInfo){
        return {};
    }
    let res = {};
    res.value = '';
    // 线形图最大多支持横向三百个点。
    let data = dataInfo.statisticsData.data;
    let info = dataInfo.statisticsInfo;
    // 行头计算
    // 取出合计项
    let lastData = dataInfo.statisticsData.lastData;
    // 合计的情况 弹出合计项；-1 全部转换
    let topN = getMaxData(data,-1,columnId, info,index);
    // 合计值
     let sum = 0;
    if(lastData){
      sum = lastData[columnId][1];
      res.info = {sum:sum};
    }

    res.data = setRowHeaderName(topN,info,0);
    // index取色器
    res.color = getColorsByIndex(index);
    //  取得轮盘颜色
    // let numColors = getColorsByNum( res.data.length);
    // for (let i=0;i<res.data.length;i++){
    //     let item = res.data[i];
    //     item.capIndex = i;
    //     item.itemStyle = {normal:{color:numColors[i]}};
    // }
    return res;
};
let valueFormatFun =  function (value,ctx,cellWidth) {
    let res = '';
    // value = '123sasfasdf阿斯顿发送到发生送123sasfasdf阿123sasfasdf阿斯顿发送到发生送送到发生送到发生到发生送到发生斯顿发送到发生送送到发生送到发生到发生送到发生送到发生送到发生到发生送到发生';
    let subMaxDeep = 0;
    if(value){
        let strArray = (value+'').split('');
        let subStr = '';

        for(var i=0;i<strArray.length;i++){
            subStr = subStr + strArray[i];
            if( ctx.measureText(subStr).width > cellWidth - 25){
                if(!res){
                    res = subStr
                }else{
                    subMaxDeep++;
                    res = res + '\n'+subStr
                }
                subStr = '';
                if(subMaxDeep == 2){
                    res = res.substring(0,res.length - 1)+'...';
                    break;
                }
            }
        }
        if(!!subStr){
            if(!res){
                res = subStr
            }else{
                subMaxDeep++;
                res = res + '\n'+subStr
            }
        }
        return {res,subMaxDeep};
    }else{
        return {res,subMaxDeep};
    }
};
// 数据解析
export const createAxisLabelFormatter = (option,computedEchartWidth,context) => {
    let cellWidth = computedEchartWidth/option.xAxis.data.length;
    var canvas = document.createElement('canvas')//首先创建一个canvas标签
    var ctx = canvas.getContext("2d");//把canvas的画笔给调出来
    ctx.font="12px sans-serif";
    // let leftWidth = ctx.measureText(yStr).width + 10;
    let maxDeep = 0;
    for(let i=0;i<option.xAxis.data.length;i++){
        let dataItem = option.xAxis.data[i];
        let subMaxDeep = valueFormatFun(dataItem,ctx,cellWidth).subMaxDeep;
        if(subMaxDeep > maxDeep){
            maxDeep = subMaxDeep;
        }
    }
    // 调整底部宽度计算出的这个属性全局共享
    option.saveMaxDeep = maxDeep;
    option.grid.y2=option.grid.y2 + maxDeep * 15
    option.xAxis.axisLabel.formatter = function (value, index) {
        let res = '';
        if(value){
            res = valueFormatFun(value,ctx,cellWidth).res;
            return res;
        }else{
            return res;
        }
    };


    return option;
};
