let sumkeyFlg = '';
let tableUtilUnShowColFilter = '';

function Compute(v) {
    if(!v) v = '';
    let width = 80;
    let subW = 0;
    var d = document.getElementById('dvCompute');

    if(d){
        d.innerHTML = v;
        subW = d.offsetWidth+32;
    }else{
        let bitCount = v.replace(/[^\x00-\xff]/g,'**').length;
        subW = bitCount * 10 + 32;
    }
    if(subW>width){
        width = subW;
    }
    return width;
}

export const tableCreateRowItem = (item, zen = '', payload = {}) => {
    if (item) {
        const field = `${zen + item.aliasTableName}_${item.name}`;
        if (tableUtilUnShowColFilter && tableUtilUnShowColFilter[field]) {
            return null;
        }
        payload.fields = [field];

        payload.title = item.aliasDisplay;
        // let bitCount = item.aliasDisplay.replace(/[^\x00-\xff]/g,'**').length;
        // payload.title = payload.title + Compute(payload.title);

        payload.contextAlign = 'right';
        payload.titleAlign = 'center';
    }
    return payload;
};

export const tableCreateColumnItem = (item, zen = '', payload = {}) => {
    if (item) {
        payload.field = `${zen + item.aliasTableName}_${item.name}`;
        payload.title = item.aliasDisplay;
        payload.width = Compute(payload.title);
        payload.isResize = true;
        payload.titleAlign = 'center';
        if (payload.isFrozen) {
            payload.contextAlign = 'right';
        } else {
            payload.contextAlign = 'right';
        }
        payload.penetrateEnable = item.penetrateEnable;
        payload.formatter = function (rowData, index, pagingIndex, field) {
            if (rowData.rowType === '0' && rowData.rowSumKey === field) {
                return '小计';
            } else if (rowData.rowType === '1' && field === sumkeyFlg) {
                return '合计';
            }
            //  return rowData[field];
            return rowData[field] ? rowData[field][0] : '';
        };
    }
    return payload;
};
// column to columnFilter
export const columnFilterItem = item => {
    const resItem = {};
    if (item) {
        if (item.fields) {
            resItem.field = item.fields[0];
        } else {
            resItem.show = false;
            resItem.field = item.title;
        }
        resItem.checked = true;
        resItem.name = item.title;
    }
    return resItem;
};
// 原始hearder 转换为 tableheader
export const tableCreateAcrossHeader = ({ rowHeaders, statsFields, columnMerge, rowMerge },colData,unShowColFilter) => {
    tableUtilUnShowColFilter = unShowColFilter;
    const titleRows = [];
    sumkeyFlg = '';
    const columns = [];
    const row1 = [];
    const leftRow = [];
    // 计算属性filter制作string
    let outField = '';
    // 筛选列表制作
    const headerFilterList = [];
    // 判断是否是两层title
    let initRowspan = 1;
    if (colData && colData.length > 0) {
        initRowspan = 2;
        // 如果只有一个static
    }

    // 制作开始
    rowHeaders.forEach(item => {
        if (sumkeyFlg === '')sumkeyFlg = `${item.aliasTableName}_${item.name}`;
        let rowspan = initRowspan;
        if(statsFields.length < 2) {
            rowspan = 1;
        }
        const rowItem = tableCreateRowItem(item, '', { rowspan : rowspan });
        if (rowItem) {
            row1.push(rowItem);
            const columnItem = tableCreateColumnItem(item, '', { isFrozen : true });
            columns.push(columnItem);
            leftRow.push(columnItem.field);
            // 筛选列表
            headerFilterList.push(columnFilterItem(rowItem));
        }
    });
    titleRows.push(row1);
    if (initRowspan === 2) {
        let count = 0;
        const row2 = [];
        let params = {};
        // 制作头层跨域
        colData.forEach(item => {
            // 两个以上
            if(statsFields.length > 1) {
                params = {};
                params.title = item?item[0]:'';
                params.titleAlign = 'center';
                const headerFilterItem = columnFilterItem(params);
                headerFilterItem.childrens = [];
                params.fields = [];
                statsFields.forEach(subfield => {
                    const zen = `col_${count}_`;
                    const tmp = `${zen + subfield.aliasTableName}_${subfield.name}`;
                    const rowItem = tableCreateRowItem(subfield, zen);
                    if (rowItem) {
                        row2.push(rowItem);
                        headerFilterItem.childrens.push(columnFilterItem(rowItem));
                        columns.push(tableCreateColumnItem(subfield, zen));
                        params.fields.push(tmp);
                    }
                });
                params.colspan = params.fields.length;
                if (params.colspan > 0) {
                    headerFilterList.push(headerFilterItem);
                    row1.push(params);
                }
            }else{
                statsFields.forEach(subfield => {
                    const zen = `col_${count}_`;
                    subfield.aliasDisplay = item?item[0]:'';
                    const rowItem = tableCreateRowItem(subfield,zen);
                    if (rowItem) {
                        row1.push(rowItem);
                        columns.push(tableCreateColumnItem(subfield,zen));
                        headerFilterList.push(columnFilterItem(rowItem));
                    }
                });
            }
            count++;
        });
        // 如果行统计开启
        if (columnMerge) {
            outField = '';
            params = {};
            params.title = '列合计';
            params.titleAlign = 'center';
            if (statsFields.length > 1){
                const headerFilterItem = columnFilterItem(params);
                headerFilterItem.childrens = [];
                params.fields = [];
                statsFields.forEach(subfield => {
                    const tmp = `${subfield.aliasTableName}_${subfield.name}`;
                    outField = `${outField},${tmp}`;
                    const rowItem = tableCreateRowItem(subfield);
                    if (rowItem) {
                        row2.push(rowItem);
                        headerFilterItem.childrens.push(columnFilterItem(rowItem));
                        columns.push(tableCreateColumnItem(subfield, '', { columnMerge : true }));
                        params.fields.push(tmp);
                    }
                });
                params.colspan = params.fields.length;
                if (params.colspan > 0) {
                    headerFilterList.push(headerFilterItem);
                    row1.push(params);
                }
            }else{
                statsFields.forEach(subfield => {
                    subfield.aliasDisplay = params.title;
                    const tmp = `${subfield.aliasTableName}_${subfield.name}`;
                    outField = `${outField},${tmp}`;
                    let rowItem = tableCreateRowItem(subfield);
                    // rowItem.titleAlign = params.titleAlign;
                    if (rowItem) {
                        headerFilterList.push(columnFilterItem(rowItem));
                        columns.push(tableCreateColumnItem(subfield, '', { columnMerge : true }));
                        row1.push(rowItem);
                    }
                });
            }
        }
        if(statsFields.length > 1) titleRows.push(row2);
    } else {
        statsFields.forEach(subfield => {
            const rowItem = tableCreateRowItem(subfield);
            if (rowItem) {
                row1.push(rowItem);
                columns.push(tableCreateColumnItem(subfield));
                headerFilterList.push(columnFilterItem(rowItem));
            }
        });
    }
    // 一层标题太多，子表格要膨胀
    if(titleRows.length > 1){
        // 多层情况
        row1.forEach(row =>{
            let row1Length = Compute(row.title);
            let subFieldsWidthSum = 0;
            row.fields.forEach(field =>{
                for (let i =0;i<columns.length;i++){
                    let col = columns[i];
                    if (col.field == field){
                        subFieldsWidthSum = subFieldsWidthSum + col.width;
                        break;
                    }
                }
            });
            if(row1Length>subFieldsWidthSum){
                updataColumns(row,columns,row1Length/subFieldsWidthSum);
            }
        })
    }

    return { titleRows, columns, leftRow, outField, headerFilterList };
};
// 根据title 更新col的width
const updataColumns = (row, columns,zoom) => {
    row.fields.forEach(field =>{
        for (let i =0;i<columns.length;i++){
            let col = columns[i];
            if (col.field == field){
                col.width = col.width*zoom;
                break;
            }
        }
    });
};

// 排序函数
function sortFun(a,b)
{
    if(a.length > b.length)return 1;
    if(a.length < b.length)return -1;
    if(a > b)return 1;
    if(a < b)return -1;
    return 0
}
// 筛选项制作
export const tableCreateHeaderRowFilterList = (tableConfig, datalist) => {
    const checkObj = {};
    const resObj = {};
    tableConfig.columns.forEach(col => {
        checkObj[col.field] = {};
        resObj[col.field] = [];
    });
    if (datalist) {
        datalist.forEach(item => {
            if (item.rowType !== '0' && item.rowType !== '1') {
                tableConfig.columns.forEach(col => {
                    const itemValue = item[col.field][0];
                    if (!checkObj[col.field][itemValue]) {
                        checkObj[col.field][itemValue] = true;
                        if (itemValue) {
                            resObj[col.field].push(itemValue);
                        } else {
                            resObj[col.field].push(' ');
                        }
                    }
                });

            }
        });
        // 最终排序
        tableConfig.columns.forEach(col => {
            resObj[col.field] = resObj[col.field].sort(sortFun);
        });
        // 排序
    }
    return resObj;
};
