import { get } from '../js/localstorage'
export function data2tableData(data = []) {
    if(!(data instanceof Array))throw new Error('data 必须是一个数组！');
    return data;
}
export function columns2tableColumns(columns = []) {
    if(!(columns instanceof Array))throw new Error('columns 必须是一个数组！');
    const array = [];
    const len = columns.length;
    for (let i =0; i< len; i++ ){
        const { name, aliasDisplay, aliasTableName,render,type, fixed,fieldComType } = columns[i];
        if(fieldComType === 'image') continue;
        // 将外部数据格式映射为内部标准格式
        const key = `${aliasTableName}_${name}`;
        const w = get(this.appId, type || key, this.localStorageWidth);
        array.push({
            key,
            value : aliasDisplay,
            realWidth : w, // 真实宽度
            width : w,
            render,
            type,
            fixed
        });
    }
    return array;
}
// 默认table-body里面的td的渲染规则，可以被columns的render方法覆盖
export function renderTableBodyTd(h, key, data) {
    //如果是图片的话...
    const value = data[key] || '';
    if(value instanceof Object){
        let {imageId,showvalue = '',showName} = value;
        if(showName) return h('span',{'class':'cell-text',domProps:{title : showvalue}},showvalue);
        return h('img',{
            style : {
                verticalAlign : 'middle',
                height : '21px',
                maxWidth : '100%',
                width:'auto'
            },
            domProps : {
                src : `/seeyon/fileUpload.do?method=showRTE&fileId=${imageId}&type=image${CsrfGuard.getUrlSurffix()}`,
                title : showvalue
            }
        });
    }
    return h('span',{'class':'cell-text',domProps:{title : value}},value);
}
