import axios from 'axios';
import env from "../../layout/env/env.js"
let HttpClient = {};

let _t = function(){
  let d = new Date();
  return '?_t='+d.getTime();
}

// 取得跨域随机数
HttpClient.getEnv = function () {
  var mainIfram_ctxPath = null;
  var mainIfram_ctxServer = null;
  var mainIfram_CsrfGuard = null;
  if(window.top.mainIfram && window.top.mainIfram._ctxPath) mainIfram_ctxPath = window.top.mainIfram._ctxPath;
  if(window.top.mainIfram && window.top.mainIfram._ctxServer)mainIfram_ctxServer = window.top.mainIfram._ctxServer;
  if(window.top.mainIfram && window.top.mainIfram.CsrfGuard)mainIfram_CsrfGuard = window.top.mainIfram.CsrfGuard;
  var _ctxPath = window.top._ctxPath || mainIfram_ctxPath || '/seeyon' ;
  var _ctxServer = window.top._ctxServer || mainIfram_ctxServer || _ctxPath;
  var CsrfGuard = window.top.CsrfGuard || mainIfram_CsrfGuard || {};
  // 兼容性设置
  window._ctxPath = _ctxPath;
  window._ctxServer = _ctxServer;
  window.CsrfGuard = CsrfGuard;
  return {_ctxPath,_ctxServer,CsrfGuard};
}

HttpClient.name = 'HttpClient',
HttpClient.env = HttpClient.getEnv()

HttpClient.getUrlSurffix = function () {
  if(HttpClient.env.CsrfGuard && HttpClient.env.CsrfGuard.getUrlSurffix){
    return HttpClient.env.CsrfGuard.getUrlSurffix()
  }
  return '';
}

  //?bussId=3351051111993459572&templateId=6579806383331953200
HttpClient.urls = {
  configUrl:process.env.NODE_ENV === 'production' ? './static/config.json':env.configUrl,
  //  configUrl:'./static/config.json',
  // 获取人员信息
  getCurrentUserInfoUrl:`${HttpClient.env._ctxPath}/rest/cap4/template/getCurrentUserInfo/`,
  //根据模板id获取运行时数据
  getDataByTemplateIdUrl:`${HttpClient.env._ctxPath}/rest/cap4/template/getDataByTemplateId/`,
  //根据栏目id获取运行时数据
  getDataByColumnIdsUrl:`${HttpClient.env._ctxPath}/rest/cap4/template/getDataByColumnIds/`,
  //根据栏目元素id获取运行时数据
  getDataByElementIdsUrl:`${HttpClient.env._ctxPath}/rest/cap4/template/getDataByElementIds/`,
  // 根据真实参数获取运行时数据
  getDataByRealParams:`${HttpClient.env._ctxPath}/rest/cap4/template/getDataByRealParams`,
};
HttpClient.axios = axios;
HttpClient.setEnv =  function (evn) {
  HttpClient.env =  Object.assign(HttpClient.env, evn);
};
// 获取栏目数据.then.catch
HttpClient.getDataByColumnIds = function (templateId,column) {
  let columnIds = [column.columnId]
  let option = {
    method:'post',
    url:HttpClient.urls.getDataByColumnIdsUrl,
    data:{
      templateId:templateId,
      columnIds:columnIds
    }
  }
  return axios(option);
};
HttpClient.getCurrentUserInfo = function () {
  let option = {
    method:'get',
    url:HttpClient.urls.getCurrentUserInfoUrl
  }
  return axios(option);
};

HttpClient.getConfig = function () {
  let option = {
    method:'get',
    url:HttpClient.urls.configUrl+_t()
  }
  return axios(option);
};
// 获取栏目数据解析器
HttpClient.resToData = function (res,column) {
  let columnData = {};
  columnData.keys = column.elements.map((item)=>{
      return item.dynamicKey;
  })
  columnData.datas = res.data.data.data || res.data.data;
  return columnData;
};


HttpClient.install = function (Vue) {
  if(Vue){
    Vue.prototype.$httpClient = HttpClient;
  }
};
export default HttpClient;
