import Cap4MUiBrowserSupport from './src/cap4-m-ui-browser-support.vue';

/* istanbul ignore next */
Cap4MUiBrowserSupport.install = function(Vue) {
  Vue.component(Cap4MUiBrowserSupport.name, Cap4MUiBrowserSupport);

  const ToastController = Vue.extend(Cap4MUiBrowserSupport);
  // 实现toast的关闭方法
  ToastController.prototype.close = function () {
    this.data.visible = false;
  };

  // 在Vue原型实现toast的DOM挂载、以及功能实现
  // 用户可以在Vue实例（Vue单文件就是一个Vue实例）通过this.$toast来访问以下内容
  Vue.prototype.$cap4BrowserSupport = (option = {}) => {
    // toast实例挂载到刚创建的div
    const instance = new ToastController({
      el : document.createElement('div'),
      propsData : {
        data : {
          text : option.text,
          visible : true
        }
      }
    });
    // 将toast的DOM挂载到body上
    document.body.appendChild(instance.$el);
    return instance;
  }
};

export default Cap4MUiBrowserSupport;
