import scrollBar from './perfect-scrollbar.common';
import  './css/cap4-scrollbar.css';
export default {
    name: 'Cap4PcUiScrollbar',
    componentName: 'Cap4PcUiScrollbar',
    props: {
        settings: {
            type: Object,
            default:()=>({})
        },
        swicher: {
            type: Boolean,
            default: true,
        },
        tag: {
            type: String,
            default: 'div'
        }
    },
    data() {
        return {
            instance: null,
            bindId:'',
            _ps_inited: false
        }
    },
    methods: {
        scrollHanle(evt) {
            this.$emit(evt.type, evt);
        },
        update() {
            const instance = this.instance;
            if (instance) {
                instance.update();
            }
        },
        init() {
            if (this.swicher) {
                if (!this._ps_inited) {
                  this._ps_inited = true;
                  this.bindId = this.settings.bindId;
                    if(this.bindId){
                      this.instance = new scrollBar("#"+this.bindId, this.settings);
                    }else{
                       this.instance = new scrollBar(this.$el, this.settings);
                    }
                } else {
                    this.update();
                }
            }
        },
        uninit() {
            this.instance.destroy();
            this.instance = null;
            this._ps_inited = false;
        },
    },
    watch: {
        swicher(val) {
            if (val && !this._ps_inited) {
                this.init();
            }
            if (!val && this._ps_inited) {
                this.uninit();
            }
        }
    },
    mounted() {
        this.init();
    },
    updated() {
        this.$nextTick(this.update);
    },
    beforeDestroy() {
        this.uninit();
    },
    render(h) {
        return h(this.tag, {
            class: ['ps-container'],
            on: {
                'ps-scroll-y': this.scrollHanle,
                'ps-scroll-x': this.scrollHanle,
                'ps-scroll-up': this.scrollHanle,
                'ps-scroll-down': this.scrollHanle,
                'ps-scroll-left': this.scrollHanle,
                'ps-scroll-right': this.scrollHanle,
                'ps-y-reach-start': this.scrollHanle,
                'ps-y-reach-end': this.scrollHanle,
                'ps-x-reach-start': this.scrollHanle,
                'ps-x-reach-end': this.scrollHanle
            }
        }, this.$slots.default);
    }
}
