let BASE_URL = 'http://cap4.v5.cmp/v1.0.0/htmls/';
function getBaseUrl (appId,route) {
    if (cmp.platform.CMPShell) {
        if(appId && (appId !== '0')) BASE_URL = `http://${appId}.v5.cmp/v1.0.0/dist/index.html`;
        else BASE_URL = 'http://cap4.v5.cmp/v1.0.0/htmls/'+ route;
    } else {
        BASE_URL = '/seeyon/m3/apps/v5/cap4/htmls/' + route;
    }
    return BASE_URL;
};
function openWebView (route, data,appId) {
    let options = {};
    if(cmp.platform.CMPShell){
        options.openWebViewCatch = 1;
    }
    cmp.href.next(`${getBaseUrl(appId,route)}`, data,options);
}
function collaboration (type, params) {
    if (type === 'new') {
        collApi.newColl({
            templateId : params.appId,
            newWebView : true
        });
    } else {
        collApi.openList({
            templeteIds:params[0],
            listTitle : params[1],
            openFrom : params[2],
            newWebView : true
        });
    }
}
export default function goUrl (item, type){
    if(!item) return undefined;
    const appId = item.appId;
    const uId = item.isUseCustomTemplate === '0' ? '0' : item.appId;
    const menuName = item.menuName;
    switch (type) {
        case 'unflowList':// 实际是无流程列表
        case 'unflowMenuCollection':// 实际是无流程列表
            openWebView(`unflow/${uId}/dist/index.html`, {
                title : menuName,
                bussId : this.bussId,
                appId,
                formId : item.formId
            },uId);
            break;
        case 'queryList':// 实际查询
        case 'queryMenuCollection':// 实际是查询
            openWebView(`query/${uId}/dist/index.html`, {
                title : menuName,
                bussId : this.bussId,
                appId
            },uId);
            break;
        case 'caclList':// 实际是统计
        case 'caclMenuCollection':// 实际是统计
            openWebView(`report/${uId}/dist/index.html`, {
                title : menuName,
                bussId : this.bussId,
                appId,
                uId
            },uId);
            break;
        case 'shortCut':
            if (item.menuType === 'listCreate') {
                collaboration('new', {
                    appId
                });
                return;
            }
            openWebView('native/form/index.html#/formmain', {
                formType : 'main',
                type : 'new',
                title : menuName,
                params : {
                    rightId : '-1',
                    moduleId : appId,
                    formTemplateId : appId,
                    moduleType : '42',
                    operateType : '0'
                }
            });
            break;
    }
}