    /*eslint-disable*/
    // 后台标识字符
    const checkList = [',','¥','%'];

    //公用转换器 formatMoney => NumberMoney
    export const moneyToNumber = (money) => {
        let res = 0;
        if(typeof money == 'string'){
            for (let i=0;i<checkList.length;i++){
                const before = checkList[i];
                let raRegExp1=new RegExp(before,"g");
                money = money.replace(raRegExp1,'');
            }
            try {
                res = parseFloat(money);
            } catch(error) {
                res = 0;
            }

        }else if(typeof money == 'number'){
            res = money;
        }else{
            res = 0;
        }
        return res;
    };
    // 是否是后台format
    export const isBackFormat = (money) => {
        money = money +'';

        for (let i=0;i<checkList.length;i++){
            const before = checkList[i];
            if(money.indexOf(before)>=0)return true;
        }
        return false;
    }

    let getZeroStr = (num)=>{
        let res = '';
        for (let i =0; i< num;i++) {
            res += '0';
        }
        return res;
    }

    //判断小数点后有几位 mode：1:强制 2：自动
    export const moneyDecimal = (money, maxDecimal,mode) => {
        let useDecimal = 0;
        let tmpMoney = money.toString();
        let tmpMoneyZ = tmpMoney.indexOf('.');
        if(mode==1){
            if(tmpMoneyZ>=0){
                let decimal = money.toString().split(".")[1].length;
                if(decimal>maxDecimal){
                    return money.toFixed(maxDecimal);
                }else{
                    return money.toFixed(decimal) + getZeroStr(maxDecimal - decimal);
                }
            }else{
                return money+'.'+getZeroStr(maxDecimal);
            }
        }
        if(mode==2){
            if(tmpMoneyZ>=0){
                let decimal = money.toString().split(".")[1].length;
                if(decimal>maxDecimal){
                    useDecimal = maxDecimal;
                }else{
                    useDecimal = decimal;
                }
            }
            let a= money.toFixed(useDecimal);
            return a;
        }
        return money;
    }
    //  万  亿  万亿 单位转换(小数位)
    export const moneyFilter = (input, decimal, mode) => {
        if(!decimal && decimal!==0)decimal = 2;
        if(!mode) mode = 2;
        let money = moneyToNumber(input);
        // 正数的情况
        if(money<10000 && money>=0){
            return moneyFilter2(input, decimal, mode);
        }
        if(money >= 10000 && money <100000000){
            let showMoney = money/10000;
            return moneyDecimal(showMoney, decimal, mode) + '万';
        }
        if(money >= 100000000 && money < 1000000000000){
            let showMoney = money/100000000;
            return moneyDecimal(showMoney, decimal, mode) + '亿';
        }
        if(money >= 1000000000000){
            let showMoney = money/1000000000000;
            return moneyDecimal(showMoney, decimal, mode) + '兆';
        }
        // 负数的情况
        if(money<0 && money>-10000){
            return moneyFilter2(input, decimal, mode);
        }
        if(money > -100000000 && money <= -10000){
            let showMoney = money/10000;
            return moneyDecimal(showMoney, decimal, mode) + '万';
        }
        if(money > -1000000000000 && money <= -100000000){
            let showMoney = money/100000000;
            return moneyDecimal(showMoney, decimal, mode) + '亿';
        }
        if(money <= -1000000000000){
            let showMoney = money/1000000000000;
            return moneyDecimal(showMoney, decimal, mode) + '兆';
        }

        return money;
    };
    //  千分位转换, 带小数点;3 : 可后台适配适配
    export const formatThousand = (input) => {
        let money = moneyToNumber(input);
        let numStr = input+'';
        //
        let index = numStr.indexOf('.');
        if(index>=0){
            let z = parseInt(money);
            let x = numStr.substring(index);
            return (z || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,')+x;
        }else{
            return (money || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,');
        }
        return money;
    };
    //  千分位转换, 带小数点;3 : 可后台适配适配
    export const moneyFilter2 = (input, decimal, mode) => {
        if(!decimal && decimal!==0)decimal = 2;
        if(!mode) mode = 3;
        if(mode == 3 && isBackFormat(input)){
            mode = 2;
            return input;
        }
        let money = moneyToNumber(input);
        let numStr = moneyDecimal(money, decimal, mode).toString();
        //
        let index = numStr.indexOf('.');
        if(index>=0){
            let z = parseInt(money);
            let x = numStr.substring(index);
            return (z || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,')+x;
        }else{
            return (money || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,');
        }
        return money;
    };

    // 日期适配
    export const autoFilter = (item , dataInfo,mode) => {
        if(!mode)mode = 2;
        let value = '';
        let lable = '';
        let res = '';
        if(!!item){
            // 日期型
            if(item instanceof Array){
                lable = item[0]?item[0]:'';
                value = item[1];
            }else{
                lable = item.lable;
                value = item.value;
            }
            // 如果后端有定义格式，走后端格式化
            if(lable != value+''){
                res = lable;
            }else{
                // 没有定义格式，走前端格式化
                if(!!value){
                    if(mode == 1){
                        res = moneyFilter(value);
                    }
                    if(mode == 2){
                        res = moneyFilter2(value);
                    }
                }
            }
        }
        if(!res&&res!==0)res='';
        return res;
    };
