/*eslint-disable*/
import { penetrationUtil } from '../statistics/commonUtil'
import themesMixin from './themesMixin'

export default {
  props:['column','templateId','bussId'],
  mixins : [themesMixin],
  data() {
    return {
      datas:{},
      keys:[]
    };
  },
  computed: {

  },
  methods: {
    dk(index,key){
      let res = null;
      if(!!this.keys && this.keys.length && this.keys.length>=index+1){
        res = this.datas[this.keys[index]];
      }
      if(key && res){
        res = res[key]
      }
      return res;
    },
    getData (callback){
      this.$httpClient.getDataByColumnIds(this.templateId,this.column).then((res)=>{
        const columnData  = this.$httpClient.resToData(res,this.column);
        console.log(columnData);
        this.datas = columnData.datas;
        this.keys = columnData.keys;
        if(callback)callback();
      }).catch(e=>{
        this.datas = {};
        this.keys = [];
        if(callback)callback();
      })
    },
    // 穿透
    goUrl (item,isEg){
      if(!item) return;
      // 兼容。。
      if(item.shortCut && item.shortCut instanceof Array){
        if(item && item.shortCut &&item.shortCut.length>0){
          isEg = item.isEg;
          item = item.shortCut[0];
        }else{
          return;
        }
      }
      if(isEg == '1')return;
      let bussId = this.bussId;
      let _ctxPath = this.$httpClient.env._ctxPath;
      let url = '';
      switch (item.type) {
        case 'unflowList':// 实际是无流程列表
        case 'unflowMenuCollection':// 实际是无流程列表
          url = `${_ctxPath}/cap4/businessTemplateController.do?method=capUnflowList&moduleId=${item.appId}&businessId=${bussId}&formId=${item.formId}${this.$httpClient.getUrlSurffix()}`;
          break;
        case 'queryList':// 实际查询
        case 'queryMenuCollection':// 实际是查询
          url = `${_ctxPath}/report4Result.do?method=showResult&designType=QUERY&designId=${item.appId}${this.$httpClient.getUrlSurffix()}`;
          break;
        case 'caclList':// 实际是统计
        case 'caclMenuCollection':// 实际是统计
          url = `${_ctxPath}/report4Result.do?method=showResult&designType=STATISTICS&designId=${item.appId}${this.$httpClient.getUrlSurffix()}`;
          break;
        // case 'flowList':// 实际是有流程列表 * 有流程只有新建没有列表
        //
        //   break;
        case 'unFlowCreateMenuCollection':// 实际是无流程新建
        case 'unflowCreate':// 实际是无流程新建
          url = `${_ctxPath}/cap4/businessTemplateController.do?method=formContent#/create?rightId=-1&moduleId=${item.appId}&moduleType=42&formTemplateId=${item.appId}${this.$httpClient.getUrlSurffix()}`;
          break;
        case 'flowCreateMenuCollection': // 实际是有流程新建
        case 'listCreate': // 新建
          url = `${_ctxPath}/collaboration/collaboration.do?method=newColl&templateId=${item.appId}${this.$httpClient.getUrlSurffix()}`;
          break;
      }
      if (!!url){
        window.open(url,item.type,'width='+(window.screen.availWidth-10)+',height='+(window.screen.availHeight-70)+ ',top=0,left=0,toolbar=no,menubar=no,scrollbars=no, resizable=no,location=no, status=no');
      }
    },
    // 统计穿透
    penetrationClick(item, dataInfo) {
      // 预览不能穿透
      if(this.preview || this.isEg) {
        return;
      }
      if(!this.appId || !this.conditions){
         alert("data上未绑定appId跟conditions！");
      }
      // 穿透
      const statisticsPopData = penetrationUtil(
        item, this.appId, this.conditions,
        dataInfo.statisticsData,
        dataInfo.statisticsInfo);

      if(window.top.$){
        window.top.$.dialog({
          id : 'stats_penetrate',
          url : statisticsPopData.url,
          title : statisticsPopData.title,
          width : window.screen.width,
          height : this.findParent().innerHeight+100,
          transParams : statisticsPopData.params
        });
      }
    }
  }
}
