/*eslint-disable*/
import {colors} from './constant.js';

// 剔除计算属性，取得lastData
export const dataFilter = (dataInfo) => {
    if(dataInfo.statisticsData.lastData){
        return dataInfo;
    }
    if(dataInfo && dataInfo.statisticsData.data){
        let lastData = dataInfo.statisticsData.data[dataInfo.statisticsData.data.length - 1];
        if(lastData.rowType === '1'){
            dataInfo.statisticsData.lastData = lastData;
            dataInfo.statisticsData.data = dataInfo.statisticsData.data.filter(item => !item.rowType);
        }else {
            // 自己计算
            let comLastData = {};
            for (let i=0;i<dataInfo.statisticsData.data.length;i++){
                let item = dataInfo.statisticsData.data[i];
                for (let arr in item) {
                    if(item[arr] && typeof item[arr] == 'object'){
                        if(!!comLastData[arr]){
                            comLastData[arr][1] = comLastData[arr][1] + valueToNumber(item[arr][1],0);
                        }else{
                            comLastData[arr] = [0,0];
                            comLastData[arr][1] = comLastData[arr][1] + valueToNumber(item[arr][1],0);
                        }
                    }
                }
            }
            dataInfo.statisticsData.lastData = comLastData;
        }
    }
    return dataInfo;
}

// 轮盘取色器
export const getColorsByNum = (num)  =>{
    if(num > colors.length){
        let count = Math.ceil(num/colors.length);
        let res = [];
        for (let i=0;i<count;i++){
            res = res.concat( colors );
        }
        return res;
    }else{
        return colors;
    }
}
export const getColorsByIndex = (i)  =>{
    return colors[i];
}
export const getColorsByNum2 = (num)  =>{
    if(num >= colors.length){
        return colors;
    }else{
        let offset = colors.length / num;//
        let backI = null;
        let res = [];
        for (let i = 0;i<colors.length;i){
            if(res.length >= num) break;
            const index = parseInt(i);
            if(backI != index){
                res.push(colors[index]);
                backI = index;
            }
            i = i + offset;
        }
        return res;
    }
}
//取得下拉菜单
export const  getSelctList = (dataInfo)  =>{
    // 入口cheeck
    let dataList = []
    if (!dataInfo || !dataInfo.statisticsInfo){
        return null;
    }
    let colData = dataInfo.statisticsData.colData;
    if(!!colData && colData.length>0){
        let value = '';
        for(let i=0;i<colData.length;i++){
            let selectOption = {};
            selectOption.key = `col_${i}_`;
            selectOption.value = colData[i][0];
            if(i==0){
                value = selectOption.key;
            }
            dataList.push(selectOption);
        }
        const option = {
            placeholder : '',
            label : 'value',
            value : 'key',
            width : 200
        }
        return {dataList,value,option};
    }else{
        return null;
    }
};
const valueToNumber = (value,def)=>{
    if(def !== 0)def = '';
    let res = 1;
    try {
        if(!!value){
            res = parseFloat(value);
        }else{
            res = def;
        }
    }catch (e){
        res = 1;
    }
    return res;
};
// 找出最大的n个值，剩余取总// -1：line全部转换启动行头制作，只在第一次循环（index=0）制作
export const getMaxData = (inputData, n, columnId, info, index, mode) => {
    n = parseInt(n);
    // 排行榜制作
    var topN = [];
    if(!n){
        return topN;
    }
    let dataInfo = {};
    if(inputData.statisticsData && inputData.statisticsInfo){
        dataInfo = inputData;
        inputData = inputData.statisticsData.data
    }
    // 去除计算属性()已经在前文剔除
    // let data = inputData.filter(item => !item.rowType)
    // 字符串补丁总值
    let data = inputData;
    // 启动行头制作
    let topPushItemBackList = [];
    if(n == -1 && index == 0){
        // 制作头游标
        topPushItemBackList.length = info.rowHeaders.length;
    }
    if(n == -1){
        for (let i = 0;i<data.length;i++) {
            let item = data[i];
            let topPushItem = {};
            topPushItem.item = item;
            topPushItem.value = valueToNumber(item[columnId][1]);
            topPushItem.lable = item[columnId][0]?item[columnId][0]:'';
            topPushItem.columnId = columnId;
            //放入队列
            topN.push(topPushItem);
            // 启动行头制作
            if(n == -1 && index == 0){
                console.log('启动行头制作---');
                topPushItem.rowHeaders =[];
                for (let h =0;h<info.rowHeaders.length;h++){
                    let rheader = info.rowHeaders[h];
                    let key = `${rheader.aliasTableName}_${rheader.name}`;

                    let rowHeaderItem = {};
                    rowHeaderItem.key=key;
                    rowHeaderItem.value=item[key][1];
                    rowHeaderItem.lable=item[key][0];
                    if(h == 0){
                        rowHeaderItem.map = rowHeaderItem.value;
                    }else{
                        rowHeaderItem.map = topPushItem.rowHeaders[h-1].map+','+rowHeaderItem.value;
                    }
                    // 前置比较
                    if(topPushItemBackList[h]){
                        if(topPushItemBackList[h].rowHeaders[h].map === rowHeaderItem.map){
                            rowHeaderItem.colSpan = 0;// 跳过此航头，前置航头+1
                            topPushItemBackList[h].rowHeaders[h].colSpan = topPushItemBackList[h].rowHeaders[h].colSpan + 1;
                        }else{
                            rowHeaderItem.colSpan = 1;
                            topPushItemBackList[h] = topPushItem;
                        }
                    } else {
                        rowHeaderItem.colSpan = 1;
                        topPushItemBackList[h] = topPushItem;
                    }
                    // 加入头
                    topPushItem.rowHeaders.push(rowHeaderItem);
                }

                // 最后缓存
            }
        }
    }else{
        // 垃圾字段回收
        let otherValue = 0;
        // 循环
        for (let i = 0;i<data.length;i++){
            let item = data[i];
            let value = valueToNumber(item[columnId][1]);

            let lable = item[columnId][0]?item[columnId][0]:'';
            if(mode == 'radar'){
                // 雷达图直接放进去，无需排序
                if(topN.length < n){
                    let topPushItem = {};
                    topPushItem.value = value;
                    topPushItem.lable = lable;
                    topPushItem.item = item;
                    topPushItem.columnId = columnId;
                    topN.push(topPushItem);
                }else {
                    break;
                }
            }else{
                //饼图不需要0 的数据
                if(!value)continue;
                //饼图不需要非数字 的数据

                if(topN.length == 0){
                    let topPushItem = {};
                    topPushItem.value = value;
                    topPushItem.lable = lable;
                    topPushItem.item = item;
                    topPushItem.columnId = columnId;
                    topN.push(topPushItem);
                }else{
                    let inFlg = false;
                    for (let j = 0;j<topN.length;j++){
                        let topItem = topN[j];
                        if(value > topItem.value){
                            let topPushItem = {};
                            topPushItem.value = value;
                            topPushItem.lable = lable;
                            topPushItem.item = item;
                            topPushItem.columnId = columnId;
                            //加入排行榜
                            inFlg = true;
                            topN.splice(j,0,topPushItem);
                            // 如果超标了就弹出最后一个
                            if(topN.length > n-1){
                                let overItem = topN.pop();
                                otherValue = otherValue + overItem.value;//替换垃圾
                            }
                            break;
                        }
                        if(j == topN.length-1){
                            if(topN.length < n - 1){
                                //加入排行榜
                                inFlg = true;
                                let topPushItem = {};
                                topPushItem.value = value;
                                topPushItem.lable = lable;
                                topPushItem.item = item;
                                topPushItem.columnId = columnId;
                                topN.push(topPushItem);
                                break;
                            }
                        }
                    }
                    if(!inFlg)otherValue = otherValue + value;
                }
            }
        }
        // 装载其他字段
        if(otherValue>0){
            let topOtherItem = {};
            topOtherItem.value = otherValue;
            topOtherItem.lable = '其他';
            topOtherItem.name = '其他';
            topN.push(topOtherItem);
        }
    }
    return topN
};
// 数据namefilter
// 行头计算
export const setRowHeaderName = (topN, info, sum, mode) => {
    //
    for(let i=0;i<topN.length;i++){
        let topItem = topN[i];
        if(topItem.item){
            // 取得名字
            let name = '';
            let index = 0;
            info.rowHeaders.forEach(item => {
                let key = `${item.aliasTableName}_${item.name}`;
                if(index === 0){
                    name = (topItem.item[key][0]?topItem.item[key][0]:'');
                }else{
                    name = name +'/'+(topItem.item[key][0]?topItem.item[key][0]:'');
                }
                index = index + 1;
            });
            topItem.name = name;
        }
        //if(mode == 'pie'){
        // 取得百分比
        if(!!topItem.value && typeof topItem.value == 'number'){
            let parent = parseInt(topItem.value / sum * 1000);
            const z = parseInt(parent/10);
            const x = (parent % 10)
            parent = z;
            if(x>0)parent = parent +'.'+ x;
            topItem.percent = parent + '%';
        }else{
            topItem.percent =  '0%';
        }

        //}
    }
    return topN;
}
//穿透配置转换
export const penetrationUtil= (item, userConditions, Data, Info )=>{
    // 当前行数据
    const currentRow = item.item;
    // 列表头
    let currentCol = {};
    if (Info) {
        for (let i = 0; i < Info.statsFields.length; i++) {
            const statsField = Info.statsFields[i];
            const diffId = `${statsField.aliasTableName}_${statsField.name}`;
            if (item.columnId.indexOf(diffId)>=0) {
                currentCol = statsField;
                break;
            }
        }
    }
    // 穿透配置

    // 左侧分组项
    const rowHeaders = Info.rowHeaders;
    var rowData = {},colData,title = "";
    for(var i=0;i<rowHeaders.length;i++){
        var header = rowHeaders[i];
        var key = header.aliasTableName + "_" + header.name;
        rowData[key] = currentRow[key][1];
        title = title + (currentRow[key][0] == undefined ? "" :  currentRow[key][0] ) + "_";
    }
    var thisKey = item.columnId;

    if(!!Data.colData && Data.colData.length>0){//有交叉项
        let colIndex =  item.columnId.substring(4,item.columnId.indexOf('_',4));
        //当前的交叉
        var currentCross = Data.colData[colIndex];
        colData = currentCross[1];
        title = title + (currentCross[0] == undefined ? "" :  currentCross[0] ) + "_";
    }
    title = title + currentCol.aliasDisplay;
    if(currentCol.calcType == "sum"){
        title = title + "(求和)";
    }else if(currentCol.calcType == "count"){
        title = title + "(计数)";
    }else if(currentCol.calcType == "avg"){
        title = title + "(平均值)";
    }else if(currentCol.calcType == "max"){
        title = title + "(最大值)";
    }else if(currentCol.calcType == "min"){
        title = title + "(最小值)";
    }
    let title2 = currentRow[thisKey][0];
    // if(!!title)title = escapeStringToHTML(title,true,false);
    // if(!!title2)title2 = escapeStringToHTML(title2,true,false);

    const statisticItem = currentCol;
    let params = {
        Info,
        rowData,
        colData,
        userConditions,
        statisticItem
    }
    // windows绑定
    let statisticsPopData = {title,title2,params};
    return statisticsPopData;
}
// 取得地址上参数
export const getUrlParam = name => {
    const reg = new RegExp("(^|&|#|/?)" + name + "=([^&]*)(&|$)", "i");
    const r = window.location.href.substr(1).match(reg);
    if (r != null) {
        let result = unescape(r[2]);
        if (result.indexOf('#') > 0) {
            result = result.slice(0, result.indexOf('#'));
        };
        return result;
    }
    return null;
}
// 取得地址上参数
export const getUrlParamXms = name => {
    const reg = new RegExp("(^|&|#|/?)" + name + "=([^&]*)(&|$)", "i");
    const r = window.location.href.substr(1).match(reg);
    if (r != null) {
        let result = decodeURI(r[2]);
        if (result.indexOf('#') > 0) {
            result = result.slice(0, result.indexOf('#'));
        };
        return result;
    }
    return null;
}
